<?php
/* SVN FILE: $Id: routes.php 2951 2006-05-25 22:12:33Z phpnut $ */
/**
 * Short description for file.
 *
 * In this file, you set up routes to your controllers and their actions.
 * Routes are very important mechanism that allows you to freely connect
 * different urls to chosen controllers and their actions (functions).
 *
 * PHP versions 4 and 5
 *
 * CakePHP :  Rapid Development Framework <http://www.cakephp.org/>
 * Copyright (c)	2006, Cake Software Foundation, Inc.
 *								1785 E. Sahara Avenue, Suite 490-204
 *								Las Vegas, Nevada 89104
 *
 * Licensed under The MIT License
 * Redistributions of files must retain the above copyright notice.
 *
 * @filesource
 * @copyright		Copyright (c) 2006, Cake Software Foundation, Inc.
 * @link				http://www.cakefoundation.org/projects/info/cakephp CakePHP Project
 * @package			cake
 * @subpackage		cake.app.config
 * @since			CakePHP v 0.2.9
 * @version			$Revision: 2951 $
 * @modifiedby		$LastChangedBy: phpnut $
 * @lastmodified	$Date: 2006-05-25 17:12:33 -0500 (Thu, 25 May 2006) $
 * @license			http://www.opensource.org/licenses/mit-license.php The MIT License
 */

//Admin routes
	
	// Login	
		$Route->connect('/'.CAKE_ADMIN, array('controller' => 'pages', 'action' => 'index', CAKE_ADMIN => true));
	// Index	
		$Route->connect('/'.CAKE_ADMIN.'/welcome', array('controller' => 'pages', 'action' => 'welcome', CAKE_ADMIN => true));
	// Noaccess	
		$Route->connect('/'.CAKE_ADMIN.'/noaccess', array('controller' => 'pages', 'action' => 'no_permissions', CAKE_ADMIN => true));
	// Pages
		$Route->connect('/'.CAKE_ADMIN.'/pages/([0-9]*)', array('controller' => 'pages', 'action' => 'pages', CAKE_ADMIN => true));
		$Route->connect('/'.CAKE_ADMIN.'/subpages/([0-9]*)/([0-9]*)', array('controller' => 'pages', 'action' => 'subpages', CAKE_ADMIN => true));
		$Route->connect('/'.CAKE_ADMIN.'/page_preview', array('controller' => 'pages', 'action' => 'page_preview', CAKE_ADMIN => true));
	// News
		$Route->connect('/'.CAKE_ADMIN.'/news/([0-9]*)', array('controller' => 'news', 'action' => 'index', CAKE_ADMIN => true));
	// Articles
		$Route->connect('/'.CAKE_ADMIN.'/articles/([0-9]*)', array('controller' => 'articles', 'action' => 'index', CAKE_ADMIN => true));
	// News categories
		$Route->connect('/'.CAKE_ADMIN.'/news_categories/([0-9]*)', array('controller' => 'news_categories', 'action' => 'index', CAKE_ADMIN => true));
	// Users
		$Route->connect('/'.CAKE_ADMIN.'/users/([0-9]*)', array('controller' => 'users', 'action' => 'index', CAKE_ADMIN => true));
	// Users groups
		$Route->connect('/'.CAKE_ADMIN.'/groups/([0-9]*)', array('controller' => 'groups', 'action' => 'index', CAKE_ADMIN => true));
	// Permissions
		$Route->connect('/'.CAKE_ADMIN.'/permissions/([0-9]*)', array('controller' => 'permissions', 'action' => 'index', CAKE_ADMIN => true));
		$Route->connect('/'.CAKE_ADMIN.'/group_permissions/([0-9]*)', array('controller' => 'group_permissions', 'action' => 'index', CAKE_ADMIN => true));
	// Forum
		$Route->connect('/'.CAKE_ADMIN.'/topics/([0-9]*)', array('controller' => 'topics', 'action' => 'index', CAKE_ADMIN => true));
		$Route->connect('/'.CAKE_ADMIN.'/comments/([0-9]*)/([0-9]*)', array('controller' => 'comments', 'action' => 'index', CAKE_ADMIN => true));
		$Route->connect('/'.CAKE_ADMIN.'/posts/([0-9]*)/([0-9]*)', array('controller' => 'posts', 'action' => 'index', CAKE_ADMIN => true));
	// Inquiries
		$Route->connect('/'.CAKE_ADMIN.'/inquiries/([0-9]*)', array('controller' => 'inquiries', 'action' => 'index', CAKE_ADMIN => true));
		$Route->connect('/'.CAKE_ADMIN.'/inquiry_answers/([0-9]*)/([0-9]*)', array('controller' => 'inquiry_answers', 'action' => 'index', CAKE_ADMIN => true));
	// Admin chat
		$Route->connect('/'.CAKE_ADMIN.'/chat', array('controller' => 'chat_messages', 'action' => 'index', CAKE_ADMIN => true));
	// Todo list
		$Route->connect('/'.CAKE_ADMIN.'/todo_list', array('controller' => 'todo_tasks', 'action' => 'index', CAKE_ADMIN => true));
	// Banners
		$Route->connect('/'.CAKE_ADMIN.'/banners/([0-9]*)', array('controller' => 'banners', 'action' => 'index', CAKE_ADMIN => true));
	// Competitions
		$Route->connect('/'.CAKE_ADMIN.'/competitions/([0-9]*)', array('controller' => 'competitions', 'action' => 'index', CAKE_ADMIN => true));
		$Route->connect('/'.CAKE_ADMIN.'/competition_answers/([0-9]*)/([0-9]*)', array('controller' => 'competition_answers', 'action' => 'index', CAKE_ADMIN => true));
	// Photos
		$Route->connect('/'.CAKE_ADMIN.'/photo_galleries/([0-9]*)', array('controller' => 'photo_galleries', 'action' => 'index', CAKE_ADMIN => true));
		$Route->connect('/'.CAKE_ADMIN.'/photos/([0-9]*)/([0-9]*)', array('controller' => 'photos', 'action' => 'index', CAKE_ADMIN => true));
		
//Page routes
	
?>
