<?php

/**
 * Controller :: Articles
 *
 * articles_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $05.02.2007$
 */

class ArticlesController extends AppController
{
    var $name = 'Articles';
    
	function admin_unpublish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Article->setId($id);
		if ($this->Article->saveField('published', 'N')) 
		{
			$this->set('msg','The article was susccessfully unpublished!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The article was not unpublished!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_publish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Article->setId($id);
		
		if ($this->Article->saveField('published', 'Y')) 
		{
			$this->set('msg','The article was susccessfully published!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The article was not published!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if ($this->Article->del($id)) 
		{
			$dir = WWW_ROOT . "upload" . DS . "articles" . DS . $id . DS;
			$this->Filemanager->deleteDir($dir);
			$this->Article->delComments('news', $id);
			
			$this->set('msg','The article was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The article was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_index($page = 1) 
	{				
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->Article->findCount(), $this->Pager->per_page, $page);
		$data = $this->Article->table($paging->offset, $paging->limit);
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','articles');

		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - ARTICLES";
		$this->render('admin', 'admin');
	}
	
	function admin_filter() 
	{
		$this->Auth->checkPermissions();
		
		$paging =$this->Pager->getPagerData($this->Article->findCount("header LIKE '%".$_GET['filter']."%'"), $this->Pager->per_page, $_GET['page']);
		$data = $this->Article->table($paging->offset, $paging->limit, $_GET['filter']);
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','articles');
		$this->set('filter', $_GET['filter']);
		
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - ARTICLES";
		$this->render('admin', 'admin');
	}
	
	function admin_add() 
	{
		$this->Auth->checkPermissions();
		$this->_back('news','/admin/articles/');	
		
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
		$js .= '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
		
		$this->set('css', $css);
		$this->set('js', $js);
		$this->set('category','articles');
		$this->set('data', $this->Session->read('data'));
		$this->set('files',  $this->Session->read('files'));
		
		if(is_file($this->Session->read('dir').'perex.jpg'))
			$this->set('perex',  $this->webroot.strstr($this->Filemanager->htmlPath($this->Session->read('dir')).'perex.jpg','upload'));
		else 
			$this->set('perex', $this->webroot.'upload/news/perex.gif');
		
		$this->Session->del('data');
		$this->pageTitle = "Drumb - ARTICLES";
		$this->render('add', 'admin');
	}
	
	function admin_save()
	{
		$this->Auth->checkPermissions();
		@$this->Session->write('redirect', strstr($_SERVER['HTTP_REFERER'], '/admin'));	
		
		if($this->Session->check('id') && empty($this->data['Article']['id'])) 
		{
			$this->data['Article']['id'] = $this->Session->read('id');
			$this->Article->setId($this->data['Article']['id']);
		} 
		else 
			$this->Article->setId($this->data['Article']['id']);
		
		if($this->Article->save($this->data)) 
		{
			if(!$this->Session->check('id') && empty($this->data['Article']['id'])) 
			{
				$this->Session->write('id' ,mysql_insert_id());
				$this->data['Article']['id'] = $this->Session->read('id');
			}
			
			$dir = WWW_ROOT . "upload" . DS . "articles" . DS . $this->data['Article']['id'] . DS; 
			$this->Filemanager->createDir($dir);
			$this->Session->write('msg','<p class="success">The article was susccessfully saved!</p>');
		}
		else
			$this->Session->write('msg','<p class="error">A error occured. The article was not saved!</p>');
		
		$this->Session->write('data',$this->data);
		
		if(isset($this->data['Article']['upload'])) 
		{
			if(($origin = $this->Filemanager->upload($_FILES['file'], $dir, array('jpg', 'gif', 'jpeg', 'txt', 'doc', 'pdf', 'xls', 'mp3'), 8000000))) 
			{
				$this->Session->write('msg','<p class="success">The file was susccessfully uploaded!</p>');
				$type = pathinfo($origin, PATHINFO_EXTENSION);
				if($type == 'jpg' || $type == 'jpeg' || $type == 'gif') 
				{
					$image = getimagesize($origin);
					if($image[0] > 400)
					{
						$ratio = ($image[0] / $image[1]);
						$image[0] = 400;
						$image[1] =	(400 / $ratio);
						$this->Filemanager->imgResize($origin,$origin,$image[0],$image[1]);
					}	
				}
			}
			@$this->Filemanager->deleteFile($dir.'perex_temp.jpg');
			$this->Session->write('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
			$this->redirect($this->Session->read('redirect'));
			exit();
		} 
		elseif(isset($this->data['Article']['perex']))
		{
			if(($dest = $this->Filemanager->upload($_FILES['perex'], $dir, array('jpg', 'gif', 'jpeg'), 8000000, 'perex_temp.jpg'))) 
			{				
				$this->Session->write('dest', $dest);
				$this->Session->write('dir', $dir);
				$this->redirect('/admin/articles/perex/');
			} 
			else
				$this->redirect($this->Session->read('redirect'));
			exit();	
		} 
		else
			$this->redirect($this->Session->read('redirect'));
	}
	
	function admin_perex($action = null) 
	{
		$this->Auth->checkPermissions();
		$dest = $this->webroot.strstr($this->Filemanager->htmlPath($this->Session->read('dest')),'upload');
		$full_dest = $this->Session->read('dest');
		
		if($action == 'crop')
		{
			if($this->Filemanager->imgCrop($full_dest,$full_dest,$this->data['Article']['x'], $this->data['Article']['y'], $this->data['Article']['width'], $this->data['Article']['height'])) 
			{
				if($this->Filemanager->imgResize($full_dest,$this->Session->read('dir').'perex.jpg',100,100)) 
				{
					$this->Filemanager->deleteFile($full_dest);
					$this->Session->write('files',  $this->Filemanager->searchDir($this->Session->read('dir'),0,'FILES'));
					$this->Session->write('msg','<p class="success">Perex was susccessfully croped!</p>');
					$this->Session->del('dest');
				}
			} 
			else
				$this->Session->write('msg','<p class="error">A error occured. The Perex was not croped!</p>');
			
			$this->redirect($this->Session->read('redirect').'');
			exit();
		}
		
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/interface/croper.php" />';
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/interface/interface.php"></script>';
		$image = getimagesize($this->Session->read('dest'));
		
		if($image[0] > 800) 
		{ 
			$ratio = ($image[0] / $image[1]);
			$image[0] = 800;
			$image[1] =	(800 / $ratio);
			$this->Filemanager->imgResize($full_dest,$full_dest,$image[0],$image[1]);
		}
		
		$this->set('width', $image[0]);
		$this->set('height', $image[1]);
		$this->set('css', $css);
		$this->set('js', $js);
		$this->set('category','articles');
		$this->set('dest', $dest);
		
		$this->pageTitle = "Drumb - PEREX CROP";
		$this->render('crop', 'admin');
	}

	function admin_delete_file()
	{	
		$this->Auth->checkPermissions();
		$dir = WWW_ROOT . "upload" . DS . "articles" . DS . $_POST['id'] . DS . $_POST['name'];
		if($this->Filemanager->deleteFile($dir)) 
		{
			$this->set('msg','The file was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The file was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}

	function admin_edit($id = null)
	{
		$this->Auth->checkPermissions();
		if(($this->Article->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/articles/');
			exit();
		}
		
		$this->Article->setId($id);
		
		if(!$this->Session->check('data'))
			$data = $this->Article->read();
		else 
		{
			$data = $this->Session->read('data');
			$this->Session->del('data');
		}
		
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
		$js .= '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';

		$dir = WWW_ROOT . "upload" . DS . "articles" . DS . $data['Article']['id'] . DS;
		@$this->Filemanager->deleteFile($dir.'perex_temp.jpg');
		$this->_back('news');
		
		$this->set('data', $data);
		$this->set('css', $css);
		$this->set('js', $js);
		$this->set('category','articles');

		$this->set('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
		
		if(is_file($dir.'perex.jpg'))
			$this->set('perex', $this->webroot.strstr($this->Filemanager->htmlPath($dir).'perex.jpg','upload'));
		else
			$this->set('perex', $this->webroot.'upload/articles/perex.gif');
			
		$this->pageTitle = "Drumb - ARTICLES";
		$this->render('edit', 'admin');
	}
}

?>
