<?php

/**
 * Controller :: Banners
 *
 * banners_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $03.02.2007$
 */

class BannersController extends AppController
{
    var $name = 'Banners';
    
	function admin_index($page = 1) 
	{
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->Banner->findCount(), $this->Pager->per_page, $page);
		$data = $this->Banner->findAll(null, null, "actived ASC, id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','banners');
		
		$this->_sessionDel();
		
		$this->pageTitle = "Drumb - BANNERS";
		$this->render('admin', 'admin');
	}
	
	function admin_add() 
	{
		$this->Auth->checkPermissions();
		$origin = $this->Filemanager->upload($_FILES['banner'], WWW_ROOT . "upload" . DS . "banners" . DS, array('swf'), 300000);
		if($origin) {	
			$data['Banner'] = array('from_date' => date("Y-m-d"),'to_date' => date("Y-m-d"),'created' => date("Y-m-d H:i:s"), 'file_name' => basename($origin));
		   	if($this->Banner->Save($data)) 
		   		$this->Session->write('msg','<p class="success">The banner was susccessfullly added!</p>');
		    else	
		   		$this->Session->write('msg','<p class="error">An error occured. The banner was not added!</p>');
		}
		$this->redirect('/admin/banners/');
	}

	function admin_delete($id = null) 
	{
		$this->Auth->checkPermissions();
		$dest = WWW_ROOT . "upload" . DS . "banners" . DS;
		$data = $this->Banner->find('id='.$id.'','file_name');
		
		if($this->Filemanager->deleteFile($dest.$data['Banner']['file_name']))
		{
			if ($this->Banner->del($id)) 
			{
				$this->set('msg','The banner was susccessfullly deleted!');
				$this->set('flag','success');
			}
			else 
			{
				$this->set('msg','An error occured. The banner was not deleted!');
				$this->set('flag','error');
			}
		} 
		else 
		{
			$this->set('msg','An error occured. The banner was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}

	function admin_ban($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Banner->setId($id);
		
		if ($this->Banner->saveField('actived', 'N')) 
		{
			$this->set('msg','The banner was susccessfullly disabled!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The banner was not disabled!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_authorize($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Banner->setId($id);
		
		if ($this->Banner->saveField('actived', 'Y')) 
		{
			$this->set('msg','The banner was susccessfullly enabled!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The banner was not enabled!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}		

	function admin_edit($id = null)
	{
		$this->Auth->checkPermissions();
		if(($this->Banner->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/banners/');
			exit();
		}
		
		$this->Banner->setId($id);
		
		if (empty($this->data))
		{
			$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
			$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
			$this->_back('banners');
			
			$this->set('category','banners');
			$this->set('css', $css);
			$this->set('js', $js);
			
			$this->set('data', $this->Banner->read());
			
			$this->pageTitle = "Drumb - BANNERS";
			$this->render('edit', 'admin');
		}
		else
		{
			if ($this->Banner->save($this->data))
				$this->Session->write('msg','<p class="success">The banner was susccessfullly changed!</p>');
			else
				$this->Session->write('msg','<p class="success">An error occured. The banner was not changed!</p>');
			
			$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/admin').'#msg/');
		}
	}
	
	function index($type = null) 
	{
		if(isset($this->params['requested']) && $type != null)
			return $this->Banner->findAll("type = '".$type."' AND actived = 'Y' AND CURDATE() >= from_date AND CURDATE() <= to_date", 'file_name');
		else 
		{ 
			$this->redirect('/error404/');
			exit();
		}
	}
}
?>