<?php

/**
 * Controller :: Comments
 *
 * comments_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $16.02.2007$
 */

class CommentsController extends AppController
{
    var $name = 'Comments';
    var $components = array ('Mailer');

	function admin_message_board($page = 1) 
	{
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->Comment->findCount("category = 'message_board'"), $this->Pager->per_page, $page);
		$data = $this->Comment->table($paging->offset, $paging->limit, 'message_board');
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','message_board');
		$this->set('type_id', 0);
		
		$this->pageTitle = "Drumb - MESSAGE BOARD";
		$this->render('adminboard', 'admin');
	}
	
	function admin_bazar($page = 1) 
	{
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->Comment->findCount("category = 'bazar'"), $this->Pager->per_page, $page);
		$data = $this->Comment->table($paging->offset, $paging->limit, 'bazar');
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','bazar');
		$this->set('type_id', 0);
		
		$this->pageTitle = "Drumb - BAZAR";
		$this->render('adminbazar', 'admin');
	}
	
	function admin_filter() 
	{	
		$this->Auth->checkPermissions();

		$paging =$this->Pager->getPagerData($this->Comment->findCount("category = '".$_GET['type']."' AND body LIKE '%".$_GET['filter']."%'"), $this->Pager->per_page, $_GET['page']);
		$data = $this->Comment->table($paging->offset, $paging->limit, $_GET['type'], $_GET['filter']);
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category',$_GET['type']);
		$this->set('filter', $_GET['filter']);
		$this->set('type_id', 0);
		
		if($_GET['type'] == 'message_board') 
		{
			$this->pageTitle = "Drumb - MESSAGE BOARD";
			$this->render('adminboard', 'admin');
		}
		elseif($_GET['type'] == 'bazar') 
		{
			$this->pageTitle = "Drumb - BAZAR";
			$this->render('adminbazar', 'admin');
		}
	}
	
	function admin_delete($type = null, $id = null, $type_id = 0)
	{	
		$this->Auth->checkPermissions();
		if($this->Comment->del($id)) {
			if($type != 'bazar' && $type != 'message_board')
			{
				if($type_id != 0 && $type != null)
					$this->Comment->updateComment($type, $type_id, '-');
			}
			
			$this->set('msg','The entry was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The entry was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_index($category = null, $id = null, $page = 1) 
	{
		$this->Auth->checkPermissions();
		$paging = $this->Pager->getPagerData($this->Comment->findCount("dnb_entry_id = '".$id."' AND category = '".$category."'"), $this->Pager->per_page, $page);
		$data = $this->Comment->table($paging->offset, $paging->limit, $category, null, $id);
		
		$this->_back($category);
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category',$category);
		$this->set('type_id', $id);
		
		$this->pageTitle = "Drumb - COMMENTS";
		$this->render('admin', 'admin');
	}
		
	function add() 
	{	
		if(empty($_POST)) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		if(!$this->Auth->validate()) 
		{
			if($_POST['category'] == 'playlists')
				$_POST['category'] = 'media-room';
			if($_POST['category'] != 'bazar' && $_POST['category'] != 'message_board' && $_POST['category'] != 'files' && $_POST['category'] != 'photos' && $_POST['category'] != 'artists' && $_POST['category'] != 'users') 
				$this->redirect('/'.$_POST['category'].'/'.$_POST['entry_id'].'/'.$_POST['name'].'/#msg_form');
			else 
			{
				if($_POST['category'] == 'files') 
					$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/media')); 
				elseif($_POST['category'] == 'photos')
					$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/photos'));
				elseif($_POST['category'] == 'artists')
					$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/artist'));
				elseif($_POST['category'] == 'users')
					$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/users'));
				else
					$this->redirect('/'.$_POST['name'].'/#msg_form');
			}
			exit();
		}
		
		$this->data['Comment']['dnb_entry_id'] = $_POST['entry_id'];
		$this->data['Comment']['body'] = $this->_processtext($this->_bb2html(strip_tags($_POST['comment'])), 56);
		$this->data['Comment']['subject'] = strip_tags($this->_processtext($_POST['subject'],30));
		$this->data['Comment']['category'] = $_POST['category'];
		$this->data['Comment']['dnb_user_id'] = $_POST['user_id'];
		
		if(!$this->Comment->validates($this->data)) 
		{
			$this->Session->write('msg_form','<p class="warning_big">You left some empty fields, fill it first!</p>');
			if($_POST['category'] == 'playlists')
				$_POST['category'] = 'media-room';
			if($_POST['category'] != 'bazar' && $_POST['category'] != 'message_board' && $_POST['category'] != 'files' && $_POST['category'] != 'photos') 
				$this->redirect('/'.$_POST['category'].'/'.$_POST['entry_id'].'/'.$_POST['name'].'/#msg_form');
			else 
			{
				if($_POST['category'] == 'files') 
					$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/media')); 
				elseif($_POST['category'] == 'photos')
					$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/photos'));
				else
					$this->redirect('/'.$_POST['name'].'/#msg_form');
			}
			exit();
		}
		
		if($this->Comment->save($this->data))
		{
			if($_POST['category'] != 'bazar' && $_POST['category'] != 'message_board')
				$this->Comment->updateComment($_POST['category'], $_POST['entry_id'], '+');
			if($_POST['category'] == 'users')
			{
				$user = $this->Comment->getUserById($_POST['entry_id']);
				$subject = 'Máš nový komentár';
				$message = '<strong>Ahoj</strong>,<br/>Užívateľ <a href="'.$this->webroot.'users/'.$this->Auth->getUserName().'/"> '.$this->Auth->getUserName().'</a> ti pridal nový komentár do tvojho <a href="http://www.dnb.sk/users/'.$user['dnb_users']['username'].'/">profilu</a>.';
				$this->Comment->sendMsg($_POST['entry_id'],$subject,$message,FATHER);
				if($user['dnb_users']['notification'] == 'Y') 
				{
					$this->Mailer->Subject = 'dnb.sk, komentar';
	   			 	$this->Mailer->Message = '<strong>Ahoj</strong>,<br/>Užívateľ <a href="http://www.dnb.sk/users/'.$this->Auth->getUserName().'/"> '.$this->Auth->getUserName().'</a> ti pridal nový komentár do tvojho <a href="http://www.dnb.sk/users/'.$user['dnb_users']['username'].'/">profilu</a>.<br/>--<br/><a href="http://www.dnb.sk">www.dnb.sk</a>';
	   			 	
					$this->Mailer->AddAddress($user['dnb_users']['username'],$user['dnb_users']['email']);
					$this->Mailer->socketmail();
				}
			}
			$this->Session->write('msg_form','<p class="tick_big">Your message was susccessfully saved!</p>');
		}
		else
			$this->Session->write('msg_form','<p class="error_big">An error occured. Your message was not saved!</p>');
		
		if($_POST['category'] != 'bazar' && $_POST['category'] != 'message_board' && $_POST['category'] != 'files' && $_POST['category'] != 'photos' && $_POST['category'] != 'artists' && $_POST['category'] != 'users') 
		{
			if($_POST['category'] == 'playlists')
				$_POST['category'] = 'media-room';
			$this->redirect('/'.$_POST['category'].'/'.$_POST['entry_id'].'/'.$_POST['name'].'/#msg_form');
		}
		else 
		{
			if($_POST['category'] == 'files') 
			{	
				$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/media').'#msg_form'); 
			}
			elseif($_POST['category'] == 'photos')
			{
				$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/photos').'#msg_form');
			}
			elseif($_POST['category'] == 'artists') 
			{	
				$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/artist').'#msg_form'); 
			}
			elseif($_POST['category'] == 'users') 
			{	
				$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/users').'#msg_form'); 
			}
			else
			{
				$this->redirect('/'.$_POST['name'].'/#msg_form');
			}
		}
	}
	
	function index($category = null, $id = null, $name = null, $page = 1, $photo_page = 1) 
	{
		if(!isset($this->params['requested']))
		{
			$this->redirect('/error404/');
			exit();
		}
			 
		$this->Pager->per_page = 15;
		$paging = $this->Pager->getPagerData($this->Comment->findCount("dnb_entry_id = '".$id."' AND category = '".$category."'"), $this->Pager->per_page, $page);
		$data = $this->Comment->table($paging->offset, $paging->limit, $category, null, $id);
			
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category',$category);
		$this->set('photo_page',$photo_page);
		$this->set('category_id', $id);
		$this->set('name', $name);
		
		$this->render('index', 'clean');
	}
	
	function bazar($page = 1) 
	{	
		$this->set('page', $page);	
		$this->pageTitle = "BAZAR, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('bazar', 'user');		
	}
	
	function recent_comments() 
	{
		$data = $this->Comment->table(0, 10, null);
		for ($i = 0;  $i < count($data); $i++)
		{
			if($data[$i]['dnb_comments']['category'] == 'bazar') 
			{
				$data[$i]['header'] = 'Bazar';
				$data[$i]['link'] = '/bazar/';
				continue;
			}
			if($data[$i]['dnb_comments']['category'] == 'message_board')
			{
				$data[$i]['header'] = 'Message board';
				$data[$i]['link'] = '/message-board/';
				continue;
			}
			$entry = array_pop($this->Comment->query("SELECT * FROM dnb_".$data[$i]['dnb_comments']['category']." WHERE id = '".$data[$i]['dnb_comments']['dnb_entry_id']."'"));
			if($data[$i]['dnb_comments']['category'] == 'news')
			{
				$data[$i]['header'] = 'News - ' . $entry["dnb_news"]['header'];
				$data[$i]['link'] = '/news/'.$entry["dnb_news"]['id'].'/'.$this->Filemanager->removeAccents($entry["dnb_news"]['header']).'/#msg_form';
			}
			if($data[$i]['dnb_comments']['category'] == 'parties')
			{
				$data[$i]['header'] = 'Parties - ' . $entry["dnb_parties"]['name'];
				$data[$i]['link'] = '/parties/'.$entry["dnb_parties"]['id'].'/'.$this->Filemanager->removeAccents($entry["dnb_parties"]['name']).'/#msg_form';
			}
			if($data[$i]['dnb_comments']['category'] == 'users')
			{
				$data[$i]['header'] = $entry["dnb_users"]['username'] . "'s profile";
				$data[$i]['link'] = '/users/'.$entry["dnb_users"]['username'].'/#msg_form';
			}
			if($data[$i]['dnb_comments']['category'] == 'playlists')
			{
				$data[$i]['header'] = 'Media room - ' . $entry["dnb_playlists"]['name'];
				$data[$i]['link'] = '/media-room/'.$entry["dnb_playlists"]['id'].'/'.$this->Filemanager->removeAccents($entry["dnb_playlists"]['name']).'/';
			}
			if($data[$i]['dnb_comments']['category'] == 'artists')
			{
				$data[$i]['header'] = 'Artists - ' . $entry["dnb_artists"]['name'];
				$data[$i]['link'] = '/artist/'.$entry["dnb_artists"]['url'].'/#msg_form';
			}
			if($data[$i]['dnb_comments']['category'] == 'photo_galleries')
			{
				$data[$i]['header'] = 'Photo galleries - ' . $entry["dnb_photo_galleries"]['header'];
				$data[$i]['link'] = '/photo-galleries/'.$entry["dnb_photo_galleries"]['id'].'/'.$this->Filemanager->removeAccents($entry["dnb_photo_galleries"]['header']).'/#msg_form';
			}
			if($data[$i]['dnb_comments']['category'] == 'files')
			{
				$data[$i]['header'] = 'Download - ' . $entry["dnb_files"]['header'];
				$data[$i]['link'] = '/media/'.$entry["dnb_files"]['id'].'/'.$this->Filemanager->removeAccents($entry["dnb_files"]['header']).'/#msg_form';
			}
			if($data[$i]['dnb_comments']['category'] == 'photos')
			{
				$gallery = array_pop($this->Comment->query("SELECT header,id FROM dnb_photo_galleries WHERE id = '".$entry['dnb_photos']['dnb_photo_gallery_id']."'"));
				$data[$i]['header'] = 'Photos - ' . $gallery["dnb_photo_galleries"]['header'];
				$data[$i]['link'] = '/photos/view/'.$gallery["dnb_photo_galleries"]['id'].'/'.$entry["dnb_photos"]['id'].'/'.$this->Filemanager->removeAccents($gallery["dnb_photo_galleries"]['header']).'/';
			}
	
		}
		$this->set('data', $data);
		$this->render('recent', 'clean');	
	}
	
	function message_board($page = 1) 
	{
		$this->set('page', $page);	
		$this->pageTitle = "MESSAGE BOARD, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('message_board', 'user');		
	}
	
	function delete($type = 'users', $id = null, $type_id = 0, $ajax = null)
	{	
		if($this->Comment->del($id)) 
		{
			$this->Comment->updateComment($type, $type_id, '-');
			if($ajax != null)
			{
				$this->set('msg','The comment was susccessfully deleted!');
				$this->set('flag','tick_big message_margin');
			}
			else
				$this->Session->write('msg_form','<p class="tick_big message_margin">The comment was susccessfully deleted!</p>');
		}
		else 
		{
			if($ajax != null)
			{
				$this->set('msg','An error occured. The comment was not deleted!');
				$this->set('flag','error_big message_margin');
			}
			else
				$this->Session->write('msg_form','<p class="error_big message_margin">An error occured. The comment was not deleted!</p>');
		}
		if($ajax != null)
			$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
		else
			$this->redirect($_SERVER['HTTP_REFERER']);
		exit();
	}
}

?>