<?php

/**
 * Controller :: CompetitionAnswers
 *
 * competition_answers_controler.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $03.02.2007$
 */

class CompetitionAnswersController extends AppController
{
    var $name = 'CompetitionAnswers';
    
    function admin_index($page = 1, $id = null) 
	{	
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->CompetitionAnswer->findCount("dnb_competition_id='".$id."'"), $this->Pager->per_page, $page);
		$data = $this->CompetitionAnswer->table($id, $paging->offset, $paging->limit);
		
		if(!$this->Session->check('parent'))
			@$this->Session->write('parent', strstr($_SERVER['HTTP_REFERER'], '/admin'));
		$this->_back('competitions',$this->Session->read('parent'));
				
		$this->set('page', $paging->page);
		$this->set('category_id', $id);

		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','competitions');
			
		$this->pageTitle = "Drumb - COMPETITIONS ANSWERS";
		$this->render('admin', 'admin');
	}
	
	function compete() 
	{
		if(!$this->Auth->validate()) 
    	{
    		$this->redirect($_SERVER['HTTP_REFERER'].'#msg_form');
    		exit();
    	}
		
		if(empty($_POST))
		{
			$this->redirect('/error404/');
			exit();
		}
		
		if($_POST['name'] == '') 
		{
			$this->Session->write('msg_form','<p class="warning_big">You must have filled name in your profile to compete!</p>');
			$this->redirect($_SERVER['HTTP_REFERER'].'#msg_form');
			exit();
		}
		
		if($this->CompetitionAnswer->findCount("dnb_user_id = '".$_POST['user_id']."' AND dnb_competition_id = '".$_POST['competition_id']."'") > 0) 
		{
			if(isset( $_POST['ajax'])) 
			{
				$this->set('msg','You have allready attended in this competition');
				$this->set('flag','error_big');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			else 
			{
				$this->Session->write('msg_form','<p class="error_big">You have allready attended in this competition</p>');
				$this->redirect($_SERVER['HTTP_REFERER'].'#msg_form');
				exit();
			}	
		}
		
		$this->data['CompetitionAnswer']['answer'] = strip_tags($_POST['answer']);
		$this->data['CompetitionAnswer']['dnb_user_id'] = $_POST['user_id'];
		$this->data['CompetitionAnswer']['dnb_competition_id'] = $_POST['competition_id'];
		
		if(!$this->CompetitionAnswer->validates($this->data)) 
		{
			$this->Session->write('msg_form','<p class="warning_big">You must enter answer to compete!</p>');
			$this->redirect($_SERVER['HTTP_REFERER'].'#msg_form');
			exit();
		}
		
		if($this->CompetitionAnswer->save($this->data))
		{
			if(isset($_POST['ajax'])) 
			{
				$this->set('msg','You answer was susccessfully saved!');
				$this->set('flag','tick_big');
			} else
				$this->Session->write('msg_form','<p class="tick_big">You answer was susccessfully saved!</p>');	
		}
		else
		{
			if(isset($_POST['ajax'])) 
			{
				$this->set('msg','An error occured. Your answer was not saved!');
				$this->set('flag','error_big');
			}
			else
				$this->Session->write('error_big','<p class="error_big">An error occured. Your answer was not saved!</p>');	
		}
		
		if(isset( $_POST['ajax'])) 
			$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
		else
			$this->redirect($_SERVER['HTTP_REFERER'].'#msg_form');
	}
}

?>