<?php

/**
 * Controller :: Competitions
 *
 * competitions_controler.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $03.02.2007$
 */

class CompetitionsController extends AppController
{
    var $name = 'Competitions';

	function admin_unpublish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Competition->setId($id);
		
		if ($this->Competition->saveField('published', 'N')) 
		{
			$this->set('msg','The competition was susccessfully unpublished!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The competition was not unpublished!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_publish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Competition->setId($id);
		
		if ($this->Competition->saveField('published', 'Y'))
		{
			$this->set('msg','The competition was susccessfully published!');
			$this->set('flag','success');
		}
		else
		{
			$this->set('msg','An error occured. The competition was not published!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if ($this->Competition->del($id)) 
		{
			$dir = WWW_ROOT . "upload" . DS . "competitions" . DS . $id . DS;
			$this->Filemanager->deleteDir($dir);
			$this->Competition->delAnswers($id);
			
			$this->set('msg','The competition was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The competition was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_index($page = 1) 
	{	
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->Competition->findCount(), $this->Pager->per_page, $page);
		$data = $this->Competition->findAll(null, "header,from_date, to_date, id, published", "published DESC, id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','competitions');
		
		$this->_sessionDel();
		
		$this->pageTitle = "Drumb - COMPETITIONS";
		$this->render('admin', 'admin');
	}
	
	function admin_filter($filter = null, $page = 1) 
	{
		$this->Auth->checkPermissions();

		$paging =$this->Pager->getPagerData($this->Competition->findCount("header LIKE '%".$_GET['filter']."%'"), $this->Pager->per_page, $_GET['page']);
		$data = $this->Competition->findAll("header LIKE '%".$_GET['filter']."%'", 'published, header, from_date, to_date, id', "published DESC, id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','competition_zone');
		$this->set('filter', $_GET['filter']);
		
		$this->_sessionDel();

		$this->pageTitle = "Drumb - COMPETITIONS";
		$this->render('admin', 'admin');
	}
	
	function admin_add($action = null) 
	{
		$this->Auth->checkPermissions();
		$this->_back('competitions');
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
		$js .= '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
		
		$this->set('js', $js);
		$this->set('css', $css);
		$this->set('category','competitions');
		$this->set('data', $this->Session->read('data'));
		$this->set('files',  $this->Session->read('files'));
		
		$this->Session->del('data');
		
		$this->pageTitle = "Drumb - COMPETITIONS";
		$this->render('add', 'admin');
	}
	
	function admin_save()
	{
		$this->Auth->checkPermissions();
		@$this->Session->write('redirect', strstr($_SERVER['HTTP_REFERER'], '/admin'));	
		
		if($this->Session->check('id') && empty($this->data['Competition']['id'])) 
		{
			$this->data['Competition']['id'] = $this->Session->read('id');
			$this->Competition->setId($this->data['Competition']['id']);
		}
		else 
			$this->Competition->setId($this->data['Competition']['id']);
		
		if($this->Competition->save($this->data)) 
		{
			if(!$this->Session->check('id') && empty($this->data['Competition']['id'])) 
			{
				$this->Session->write('id' ,mysql_insert_id());
				$this->data['Competition']['id'] = $this->Session->read('id');
			}
			
			$dir = WWW_ROOT . "upload" . DS . "competitions" . DS . $this->data['Competition']['id'] . DS; 
			$this->Filemanager->createDir($dir);
			$this->Session->write('msg','<p class="success">The competition was susccessfully saved!</p>');
		}
		else
			$this->Session->write('msg','<p class="error">An error occured. The competition was not saved!</p>');
		
		$this->Session->write('data',$this->data);
		
		if(isset($this->data['Competition']['upload'])) 
		{
			if(($origin = $this->Filemanager->upload($_FILES['file'], $dir, array('jpg', 'gif', 'jpeg', 'txt', 'doc', 'pdf', 'xls', 'mp3'), 8000000))) 
			{
				$this->Session->write('msg','<p class="success">The file was susccessfully uploaded!</p>');
				$type = pathinfo($origin, PATHINFO_EXTENSION);
				if($type = 'jpg' || $type = 'jpeg' || $type = 'gif') 
				{
					$image = getimagesize($origin);
					if($image[0] > 400)
					{
						$ratio = ($image[0] / $image[1]);
						$image[0] = 400;
						$image[1] =	(400 / $ratio);
						$this->Filemanager->imgResize($origin,$origin,$image[0],$image[1]);
					}
						
				}
			}
			$this->Session->write('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
			$this->redirect($this->Session->read('redirect'));
			exit();
		} 
		else 
			$this->redirect($this->Session->read('redirect'));
	}
	
	function admin_delete_file()
	{	
		$this->Auth->checkPermissions();
		$dir = WWW_ROOT . "upload" . DS . "competitions" . DS . $_POST['id'] . DS . $_POST['name'];
		if($this->Filemanager->deleteFile($dir)) 
		{
			$this->set('msg','The file was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The file was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}

	function admin_edit($id = null)
	{
		$this->Auth->checkPermissions();
		if(($this->Competition->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/competitions/');
			exit();
		}
		
		$this->Competition->setId($id);
		
		if(!$this->Session->check('data'))
			$data = $this->Competition->read();
		else
			$data = $this->Session->read('data');
		
		$this->Session->del('data');
		
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
		$js .= '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
		$dir = WWW_ROOT . "upload" . DS . "competitions" . DS . $data['Competition']['id'] . DS;
		$this->_back('competitions');
		
		$this->set('data', $data);
		$this->set('js', $js);
		$this->set('css', $css);
		
		$this->set('category','competitions');
		$this->set('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
		
		$this->pageTitle = "Drumb - COMPETITIONS";
		$this->render('edit', 'admin');
	}
	
	function get_by_tag($tag = null)
	{
		if($tag != null && isset($this->params['requested'])) 
			return $this->Competition->findAll("published = 'Y' AND CURDATE() >= from_date AND CURDATE() <= to_date AND tag LIKE '".$tag."'" ,'id, header, from_date, to_date, popularity', null, 10);
			
	}
	
	function index($id = null, $name = null) 
	{	
		if(isset($this->params['requested']) && $id == null && $name == null)
			return $this->Competition->findAll("published = 'Y' AND CURDATE() >= from_date AND CURDATE() <= to_date" ,'id, header');
		
		$this->Competition->updatePopularity($id, '+');
		$data = $this->Competition->find("id = '".$id."' AND published = 'Y' AND CURDATE() >= from_date");
		
		if(empty($data)) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$news = $this->requestAction('/news/get_by_tag/'.$data['Competition']['tag'].'/');
		$parties = $this->requestAction('/parties/get_by_tag/'.$data['Competition']['tag'].'/');
		$photo_galleries = $this->requestAction('/photo_galleries/get_by_tag/'.$data['Competition']['tag'].'/');
		$competitions = $this->requestAction('/competitions/get_by_tag/'.$data['Competition']['tag'].'/');
		
		$related = array();
		
		if(!empty($news))
		{
			foreach($news as $item) 
				$related[] = array('cat' => 'news', 'header' => $item['dnb_news']['header'], 'id' => $item['dnb_news']['id'], 'views' => $item['dnb_news']['popularity'], 'comments' => $item['dnb_news']['comments'], 'publish_date' => $item['dnb_news']['publish_date'], 'color' => $item['dnb_news_categories']['color'], 'category' => $item['dnb_news_categories']['name'], 'user' => $item['dnb_users']['username']);	
		}
		if(!empty($photo_galleries))
		{
			foreach($photo_galleries as $item) 
			{
				$photo = $this->Filemanager->searchDir(WWW_ROOT . 'upload' . DS . 'photos' . DS . $item['PhotoGallery']['id'] . DS,0,'FILES',0,0,1);
				$related[] = array('cat' => 'photos', 'path' => $photo[0]['File']['path'], 'cor' => $this->Filemanager->squareImg($photo[0]['File']['path']), 'header' => $item['PhotoGallery']['header'], 'id' => $item['PhotoGallery']['id'], 'views' => $item['PhotoGallery']['popularity'], 'comments' => $item['PhotoGallery']['comments'], 'date' => $item['PhotoGallery']['date'], 'city' => $item['PhotoGallery']['city'], 'club' => $item['PhotoGallery']['club'], 'user' => $item['PhotoGallery']['authors']);
			}
		}
		if(!empty($parties))
		{
			foreach($parties as $item) 
				$related[] = array('cat' => 'parties', 'header' => $item['Party']['name'], 'id' => $item['Party']['id'], 'views' => $item['Party']['popularity'], 'comments' => $item['Party']['comments'], 'date' => $item['Party']['date'], 'city' => $item['Party']['city'], 'club' => $item['Party']['club'], 'state' => $item['Party']['state']);
		}
		if(!empty($competitions))
		{
			foreach($competitions as $item) 
			{
				if($item['Competition']['header'] == $data['Competition']['header'] && $data['Competition']['id'] == $item['Competition']['id'])
					continue;
				$related[] = array('cat' => 'competitions', 'header' => $item['Competition']['header'], 'id' => $item['Competition']['id'], 'views' => $item['Competition']['popularity'], 'from_date' => $item['Competition']['from_date'], 'to_date' => $item['Competition']['to_date']);
			}
		}
			
		$this->set('data', $data);
		$this->set('related', $related);
		
		$this->pageTitle = "COMPETITIONS - ".$data['Competition']['header'].", dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('index', 'user');
	}
}

?>