<?php

/**
 * Component :: Auth
 *
 * auth.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $06.02.2007$
 */

class AuthComponent extends Object 
{
	var $components = array('Session');
	
	var $session_name = 'dnb_user';
	var $controller = null; 
	
	var $user_table_login      		= 'username';
	var $user_table_online      	= 'online';
	var $user_table_name      		= 'name';
    var $user_table_passwd     	 	= 'passwd';
    var $user_table_gid       		= 'dnb_group_id';
    var $user_table_state     		= 'state';
    var $user_table_sex     		= 'sex';
    var $user_table_last_visit 		= 'last_visit';
    var $user_table_ip              = 'ip';
    var $group_table_name      		= 'name';
    var $group_table_state      	= 'perm_type';
    var $perm_group_table_group_id 	= 'dnb_group_id'; 
    var $perm_group_table_perm_id 	= 'dnb_permission_id';
 
    var $user_state		  		 	= array('inactive' => 'inactive', 'banned' => 'banned', 'authorized' => 'authorized');
    var $group_state		 	 	= array('deny' => 'deny', 'allow' => 'allow');

	var $user_model       			= 'User';
    var $permission_model 			= 'Permission';
    var $group_model	 			= 'Group'; 
    var $permission_group_model 	= 'GroupPermission';	
    
    var $login_page		 			= '/admin/';
    var $noaccess_page 	 			= '/admin/noaccess/';
    var $logout_page 	 			= '/users/logout/';
	
    function startup(&$controller)
    {
       $this->controller = &$controller;
    }  
    
	function login($username = null, $password = null) 
	{ 
		if($username == null || $password == null)
			return false;
		
		loadModel($this->user_model);
		$userModel = & new $this->user_model;
		
		$conditions = $this->user_table_login." = '".$username."' AND ";
		$conditions .= $this->user_table_passwd." = '".$password."'";
		$fields = array('id', $this->user_table_gid, $this->user_table_state, $this->user_table_login, $this->user_table_name, $this->user_table_sex, $this->user_table_passwd);
		
		$data = $userModel->find($conditions, $fields);

		if(empty($data)) 
			return false;
		
		if($this->user_state['banned'] == $data[$this->user_model][$this->user_table_state]) 
			return 'banned';

		if($this->user_state['inactive'] == $data[$this->user_model][$this->user_table_state]) 
			return 'inactive';	
		
		loadModel($this->group_model);
		$groupModel = & new $this->group_model;
		
		$fields = array($this->group_table_name, $this->group_table_state);
		$conditions = "id = '".$data[$this->user_model][$this->user_table_gid]."'";
		$data[$this->user_model][$this->group_model] = array_pop($groupModel->find($conditions, $fields));
		
		if($this->group_state['deny'] == $data[$this->user_model][$this->group_model][$this->group_table_state]) 
			return 'banned';	
		
		$userModel->setId($data[$this->user_model]['id']);
		$ip = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
		
		$userModel->saveField($this->user_table_last_visit, date("Y-m-d H:i:s"));
		$userModel->saveField($this->user_table_ip, $ip);
		
		return $this->_registerSession($data);	
	}
	
	function logout() 
	{ 
		loadModel($this->user_model);
		$userModel = & new $this->user_model;
		$userModel->setId($this->getUserId());
		$userModel->saveField($this->user_table_online, '0000-00-00 00:00:00');
		$data = $this->Session->read($this->session_name);
		$this->_destroySession();
		
		return $data;
	}
	
	function validate() 
	{	
		if($this->Session->check($this->session_name))
			return true;
		else 
			return false;
	}
	
	function checkPermissions()
	{	
		if(!$this->validate()) 
		{
			$this->controller->redirect($this->login_page);
			exit();
		}

		if($this->getUserGroupId() == USERS) 
		{
			$this->controller->redirect('/news/');
			exit();
		}
	
		$data = $this->Session->read($this->session_name);
		$requested_permission = strtolower($this->controller->name);
		$group_id = $data[$this->user_model][$this->user_table_gid];

		loadModel($this->permission_model);
		$permission_model = & new $this->permission_model;
		
		$permissions = $permission_model->findByName($requested_permission);
		
		if(empty($permissions)) 
		{
			$this->controller->redirect($this->noaccess_page);
			return false;
		}
		
		loadModel($this->permission_group_model);
		$permission_group_model = & new $this->permission_group_model;
		
		$conditions = $this->perm_group_table_group_id." = '".$group_id."' AND ";
		$conditions .= $this->perm_group_table_perm_id." = '".$permissions[$this->permission_model]['id']."'";
		
		if($permission_group_model->findCount($conditions) == 0 && strtolower($this->controller->action) != 'admin_welcome') 
		{
			$this->controller->redirect($this->noaccess_page);
			return false;	
		}	

		return true;
	}

	function getUser() 
	{
		if($this->validate($this->session_name))
			return $this->Session->read($this->session_name);
		else
			return false;
	}
	
	function getUserPasswd() 
	{
		if($this->validate($this->session_name))
		{
			$data = $this->Session->read($this->session_name);
			return $data[$this->user_model][$this->user_table_passwd];
		}
		else
			return false;
	}

	function getUserId() 
	{
		if($this->validate($this->session_name))
		{
			$data = $this->Session->read($this->session_name);
			return $data[$this->user_model]['id'];
		}
		else
			return false;
	}
	
	function getUserFullName() 
	{
		if($this->validate($this->session_name))
		{
			$data = $this->Session->read($this->session_name);
			return $data[$this->user_model][$this->user_table_name];
		}
		else
			return false;
	}
	
	function setUserFullName($name = '') 
	{
		if($this->validate($this->session_name))
		{
			$data = $this->Session->read($this->session_name);
			$data[$this->user_model][$this->user_table_name] = $name;
			$this->Session->write($this->session_name, $data);
			return $name;
		}
		else
			return false;
	}
	
	function getUserName() 
	{
		if($this->validate($this->session_name))
		{
			$data = $this->Session->read($this->session_name);
			return $data[$this->user_model][$this->user_table_login];
		}
		else
			return false;
	}
	
	function getUserSex() 
	{
		if($this->validate($this->session_name))
		{
			$data = $this->Session->read($this->session_name);
			return $data[$this->user_model][$this->user_table_sex];
		}
		else
			return false;
	}
	
	function setSex($sex = 'MALE') 
	{
		if($this->validate($this->session_name))
		{
			$data = $this->Session->read($this->session_name);
			$data[$this->user_model][$this->user_table_sex] = $sex;
			$this->Session->write($this->session_name, $data);
			return $sex;
		}
		else
			return false;
	}
	
	function getUserGroupId() 
	{
		if($this->validate($this->session_name)) 
		{
			$data = $this->Session->read($this->session_name);
			return $data[$this->user_model][$this->user_table_gid];
		}
		else
			return false;
	}

	function getUserState() 
	{
		if($this->validate($this->session_name)) 
		{
			$data = $this->Session->read($this->session_name);
			return $data[$this->user_model][$this->user_table_state];
		}
		else
			return false;	
	}
	
	function _registerSession($data = null)
	{	
		$this->Session->write($this->session_name, $data);
		return $data;
	}
	
	function _destroySession()
	{	
		$data = $this->Session->read($this->session_name);
		$this->Session->del($this->session_name);
		$this->Session->destroy();
		return $data;
	}
}
?>