﻿<?php

/**
 * Component :: FileManager
 *
 * filemanager.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $22.03.2007$
 */

class FilemanagerComponent extends Object {
	
	var $controller = null; 
	var $components = array('Session');
	var $index = 0;
	var $adress = '';
		   
    function startup(&$controller)
    {
       $this->controller = &$controller;
       $this->adress = $this->controller->webroot; 
    } 
    
    // $file: file to uploade
    // $dest: destination for upload
    // $types: only files of this types
    // $size: max size of file
    // $name: explicit file name
    function upload($file = null, $dest = null, $types, $size = 8000000, $name = null) 
    {
    	if($file == null || $dest == null)
    		return false;
    		  	
    	if(!$file || $file["size"] > $size)
		    $this->Session->write('msg','<p class="error">The file was not uploaded. Max file size should by less than '.($size / 1000000).'MB!</p>');
		elseif($file["error"] == UPLOAD_ERR_NO_FILE)
		    $this->Session->write('msg','<p class="error">The file was not uploaded. Bad file, select other one!</p>');
		elseif($file["error"])
		    $this->Session->write('msg','<p class="error">The file was not uploaded. Contact the site adminstrator!</p>');
		elseif(!in_array(strtolower(pathinfo($file["name"], PATHINFO_EXTENSION)), $types))
		    $this->Session->write('msg','<p class="error">The file was not uploaded. Type of file should by '.implode(",", $types).'!</p>');
	 	else 
	 	{
		 	if($name != null)  
				$fulldest = $dest.$name;
	    	else 
	    	{
	    		$name = $this->removeAccents(pathinfo($file['name'], PATHINFO_FILENAME)).'.'.strtolower(pathinfo($file['name'], PATHINFO_EXTENSION));
			if($name == 'thumb.jpg' || $this->removeAccents(pathinfo($file['name'], PATHINFO_FILENAME)) == 'thumb')
			$name = 'photo_'.rand(5, 15).'.'.strtolower(pathinfo($file['name'], PATHINFO_EXTENSION));
	    		$fulldest = $dest.$name;
				
	    		while(is_file($fulldest)) 
	    		{
					$name = 'copy_'.$name;
	    			$fulldest = $dest.$name;
	    		}
	    	}
	    	
	 		if(move_uploaded_file($file["tmp_name"], $fulldest))
				return $fulldest;
		}
		return false;
    }
    
    // $file: file to delete
    function deleteFile($file = null)
    {
    	if($file == null)
    		return false;
    	if(unlink($file))
    		return true;	
    	return false;
    }

    // $dir: directory to delete
    function deleteDir($dir = null) 
    {
    	if($dir == null)
    		return false;
    	
    	$tree = $this->searchDir($dir, $maxdepth = -1 , $mode = "FULL");
    	
    	foreach($tree as $value) 
    	{
    		@unlink(($value['File']['path']));
    	}
    	
    	foreach($tree as $value) 
    	{
    		@rmdir(($value['Dir']));
    	}
    	
    	return true;
    }
    // $dir: image
    function squareImg($img) 
    {
    	$size = getimagesize($img);
		$width = $size[0];
		$height = $size[1];
		$x = 0;
		$y = 0;					
		if($width> $height)
		{
			$x = ceil(($width - $height) / 2 );
			$width = $height;
		} 
		elseif($height> $width)
		{
			$y = ceil(($height - $width) / 2);
			$height = $width;
		}
		return array('x' => $x,'y' => $y,'width' => $width,'height' => $height);
	}
    
    // $dir: directory to create
    function createDir($dir = null) 
    {
   		if(!is_dir($dir))
   		{
   			if(substr($dir,strlen($dir) - 1,strlen($dir)) == DS)
   				$dir = substr($dir,0,strlen($dir) - 1);
			$oldumask = umask(0); 
			@mkdir($dir, 0777);
			umask($oldumask);
			return true;
		}
		return false;
    }

	// $olddir: directory to rename
	// $newdir: new name of directory
    function renameDir($olddir = null, $newdir = null) 
    {
   		if(is_dir($olddir) && rename($olddir, $newdir))
			return true;
		elseif($this->createDir($newdir))
			return true;
		return false;
    }
    
    // $oldfile: file to rename
	// $newfile: new name of file
	function renameFile($oldfile, $newfile) {
	   if(!rename($oldfile, $newfile)) 
	   {
	      if(copy($oldfile, $newfile)) 
	      {
	         $this->deleteFile($oldfile);
	         return true;
	      }
	      return false;
	   }
	   return true;
	}
	
    // $dir: destination directory
    // $file: zip file to unzip
    function unzip($dir = null, $file = null, $size = 8000000) 
    {
		if($dir == null || $file == null)
    		return false;
  
    	if(!$file || $file["size"] > $size)
    	{
		    $this->Session->write('msg','<p class="error">The file was not uploaded. Max file size should by less than '.($size / 1000000).'MB!</p>');
			return false;
    	}
    	
		if(($zip = zip_open($file))) 
    	{	
		    while($zip_entry = zip_read($zip)) 
		    {
		        $entry = zip_entry_open($zip,$zip_entry);
		        $filename = $this->removeAccents(pathinfo(zip_entry_name($zip_entry), PATHINFO_FILENAME)).'.'.strtolower(pathinfo(zip_entry_name($zip_entry), PATHINFO_EXTENSION));
		        $target_dir = $dir.substr($filename,0,strrpos($filename,'/'));
		        $filesize = zip_entry_filesize($zip_entry);
		        
		        if(is_dir($target_dir) || $this->createDir($target_dir)) 
		        {
		            if($filesize > 0) 
		            {
		                $contents = zip_entry_read($zip_entry, $filesize);
		                file_put_contents($dir.$filename,$contents);
		                $files[] = $filename;
		            }
		        }
		    }
    	}
    	zip_close($zip);
    	return $files;
    }
	
    // $dir : dir to browse
	// $maxdepth : how deep to browse (-1=unlimited)
	// $mode : "FULL"|"DIRS"|"FILES"
	// $d : must not be defined
	function searchDir ($dir, $maxdepth = -1 , $mode = "FULL" , $d = 0, $index = 0, $count = 0)
	{
		if (substr ( $dir , strlen ( $dir ) - 1) != DS) 
	   		$dir .= DS;    
	   	$dirlist = array();
	   	
		if($mode != "FILES")
		{ 
			$dirlist[$index]['Dir'] = $dir; 
			$index++;
		}
   		if($handle = @opendir ($dir))
   		{
       		while(false !== ($file = readdir($handle)) && ($count > $index || $count == 0))
       		{
       		   if($file != '.' && $file != '..')
        	   {
	           		$file = $dir . $file;
	             	if (!is_dir ( $file )) 
	              	{ 
	              		if ($mode != "DIRS") 
	              		{ 
	              			$dirlist[$index]['File']['path'] = $file;
	              			$dirlist[$index]['File']['type'] = strtolower(pathinfo($file, PATHINFO_EXTENSION));
	              			$dirlist[$index]['File']['name'] = basename($file);
	              			$dirlist[$index]['File']['size'] = filesize($file);
	              			$dirlist[$index]['File']['link'] = $this->adress.strstr($this->htmlPath($file), 'upload');
	              			$index++;
	              		} 
	              	}
	             	elseif($d >=0 && ($d < $maxdepth || $maxdepth < 0))
	              	{
	              	  $result = $this->searchDir ( $file . DS , $maxdepth , $mode , $d + 1, $index) ;
	                  $dirlist = array_merge ( $dirlist , $result ) ;
	            	}
       			}	
       		}
       closedir ($handle) ;
       $index = 0;
   	   }
   	   return ($dirlist) ;
	}
	
	// $path : path to translate
	function htmlPath($path) {
 		if ($path == "")
     	  return false;
     	  
	   $path = trim(preg_replace("/\\\\/", "/", (string)$path));
	
	   if (!preg_match("/(\.\w{1,4})$/", $path)  && 
	       !preg_match("/\?[^\\/]+$/", $path)  && 
	       !preg_match("/\\/$/", $path))
	   {
	       $path .= '/';
	   }
	
	   $pattern = "/^(\\/|\w:\\/|https?:\\/\\/[^\\/]+\\/)?(.*)$/i";
	
	   preg_match_all($pattern, $path, $matches, PREG_SET_ORDER);
	
	   $path_tok_1 = $matches[0][1];
	   $path_tok_2 = $matches[0][2];
	
	   $path_tok_2 = preg_replace(array("/^\\/+/", "/\\/+/"), array("", "/"), $path_tok_2);
	
	   $path_parts = explode("/", $path_tok_2);
	   $real_path_parts = array();
	
	    for ($i = 0, $real_path_parts = array(); $i < count($path_parts); $i++)
	    {
	        if ($path_parts[$i] == '.')
	        {
	            continue;
	        }
	        else if ($path_parts[$i] == '..')
	        {
	            if (  (isset($real_path_parts[0])  &&  $real_path_parts[0] != '..')
	               || ($path_tok_1 != "")  )
	            {
	                array_pop($real_path_parts);
	                continue;
	            }
	        }
	
	        array_push($real_path_parts, $path_parts[$i]);
	    }
	
	   return $path_tok_1 . implode('/', $real_path_parts);
	}
	
	// $sourcefile : source image
	// $destfile : destination image
	// $forcedwidth : width to change
	// $forcedheight: height to change
	// $imgcomp : must not be defined
	function imgResize($sourcefile, $destfile, $forcedwidth, $forcedheight, $imgcomp=0) {
	   
		if (!$sourcefile)
	      return false;

	   $g_imgcomp=100-$imgcomp;
	   $g_srcfile=$sourcefile;
	   $g_dstfile=$destfile;
	   $g_fw=$forcedwidth;
	   $g_fh=$forcedheight;
	   $g_type="";

	   if(strpos($g_srcfile,".jpg")) $g_type="jpg";
	   else if(strpos($g_srcfile,".jpeg")) $g_type="jpg";
	   else if(strpos($g_srcfile,".gif")) $g_type="gif";
	   else if(strpos($g_srcfile,".png")) $g_type="png";
	   else if(strpos($g_srcfile,".JPG")) $g_type="jpg";
	   else if(strpos($g_srcfile,".JPEG")) $g_type="jpg";
	   else if(strpos($g_srcfile,".GIF")) $g_type="gif";
	   else if(strpos($g_srcfile,".PNG")) $g_type="png";
	   	 
	   else 
	   { 	   
	   	$this->Session->write('msg','<p class="error">The image size was not changed. Type of image should by jpg, jpeg, png, gif!</p>');
	      return false;
	   }
	   if(file_exists($g_srcfile)) 
	   {
	       $g_is=getimagesize($g_srcfile);
	       if(($g_is[0]-$g_fw)>=($g_is[1]-$g_fh))
	       {
	          $g_iw=$g_fw;
	          $g_ih=($g_fw/$g_is[0])*$g_is[1];
	       }
	       else 
	       {
	          $g_ih=$g_fh;
	          $g_iw=($g_ih/$g_is[1])*$g_is[0];
	       }
	
	       if($g_type=="jpg") $img_src=@imagecreatefromjpeg($g_srcfile);
	       if($g_type=="gif") $img_src=@imagecreatefromgif($g_srcfile);
	       if($g_type=="png") $img_src=@imagecreatefrompng($g_srcfile);
	       if(!$img_src)  
	       {
	          @imagedestroy($img_src);
	          @imagedestroy($img_dst);
	          return false;
	       }
	
	       if($g_type=="gif")
	       {
	       		$img_dst=imagecreate($g_iw,$g_ih);
	  			imagecopyresized($img_dst, $img_src, 0, 0, 0, 0, $g_iw, $g_ih, $g_is[0], $g_is[1]);
	       }
	       else
	       {
	       		$img_dst=imagecreatetruecolor($g_iw,$g_ih);
	       		imagecopyresampled($img_dst, $img_src, 0, 0, 0, 0, $g_iw, $g_ih, $g_is[0], $g_is[1]);
	       }

	       if($g_type=="jpg") imagejpeg($img_dst, $g_dstfile, $g_imgcomp);
	       if($g_type=="gif") imagegif($img_dst, $g_dstfile);
	       if($g_type=="png") imagepng($img_dst, $g_dstfile);
	       
	       @imagedestroy($img_src);
	       @imagedestroy($img_dst);
	       return true;
	   }
	   else 
	   {
	      @imagedestroy($img_src);
	      @imagedestroy($img_dst);
	      return false;
	   }
	}
	
	// $src : source image
	// $dst : destination image
	// $x : x axes of image to crop
	// $y: y axes of image to crop
	// $w : width of image to crop
	// $h : height of image to crop
	function imgCrop($src, $dst, $x, $y, $w, $h){
	   $g_type="";

	   if(strpos($src,".jpg")) $g_type="jpg";
	   else if(strpos($src,".jpeg")) $g_type="jpg";
	   else if(strpos($src,".gif")) $g_type="gif";
	   else if(strpos($src,".png")) $g_type="png";
	   else if(strpos($src,".JPG")) $g_type="jpg";
	   else if(strpos($src,".JPEG")) $g_type="jpg";
	   else if(strpos($src,".GIF")) $g_type="gif";
	   else if(strpos($src,".PNG")) $g_type="png";
	   
	   else
	   {
	   	  $this->Session->write('msg','<p class="error">The image was not croped. Type of image should by jpg, jpeg, png, gif!</p>');
	      return false;
	   }
	
	   if(file_exists($src))    
	   { 
	       $g_is=getimagesize($src);

			//SOURCE RESOURCE (img_src)
		   if($g_type=="jpg") $img_src=imagecreatefromjpeg($src);
	       if($g_type=="gif") $img_src=imagecreatefromgif($src);
	       if($g_type=="png") $img_src=imagecreatefrompng($src);
	       
	       //DESTINATION RESOURCE (img_dst)
	       if($g_type=="gif")
	       	$img_dst=imagecreate($w,$h);
	       else
	       	$img_dst=imagecreatetruecolor($w,$h);
	
		   imagecopyresized($img_dst, $img_src, 0, 0, $x, $y, $w, $h, $w, $h);
	       if($g_type=="jpg") imagejpeg($img_dst, $dst, 100);
	       if($g_type=="gif") imagegif($img_dst, $dst);
	       if($g_type=="png") imagepng($img_dst, $dst);
	       
	       imagedestroy($img_dst);
	       return true;
	   }
	   else
	       return false;
	}
	
	// $string : string for remove accents	
	function removeAccents($string) {
	   	
       	if ($this->_seemsUtf8($string)) 
       	{
             	$chars = array(
               // Decompositions for Latin-1 Supplement
               chr(195).chr(128) => 'A', chr(195).chr(129) => 'A',
               chr(195).chr(130) => 'A', chr(195).chr(131) => 'A',
               chr(195).chr(132) => 'A', chr(195).chr(133) => 'A',
               chr(195).chr(135) => 'C', chr(195).chr(136) => 'E',
               chr(195).chr(137) => 'E', chr(195).chr(138) => 'E',
               chr(195).chr(139) => 'E', chr(195).chr(140) => 'I',
               chr(195).chr(141) => 'I', chr(195).chr(142) => 'I',
               chr(195).chr(143) => 'I', chr(195).chr(145) => 'N',
               chr(195).chr(146) => 'O', chr(195).chr(147) => 'O',
               chr(195).chr(148) => 'O', chr(195).chr(149) => 'O',
               chr(195).chr(150) => 'O', chr(195).chr(153) => 'U',
               chr(195).chr(154) => 'U', chr(195).chr(155) => 'U',
               chr(195).chr(156) => 'U', chr(195).chr(157) => 'Y',
               chr(195).chr(159) => 's', chr(195).chr(160) => 'a',
               chr(195).chr(161) => 'a', chr(195).chr(162) => 'a',
               chr(195).chr(163) => 'a', chr(195).chr(164) => 'a',
               chr(195).chr(165) => 'a', chr(195).chr(167) => 'c',
               chr(195).chr(168) => 'e', chr(195).chr(169) => 'e',
               chr(195).chr(170) => 'e', chr(195).chr(171) => 'e',
               chr(195).chr(172) => 'i', chr(195).chr(173) => 'i',
               chr(195).chr(174) => 'i', chr(195).chr(175) => 'i',
               chr(195).chr(177) => 'n', chr(195).chr(178) => 'o',
               chr(195).chr(179) => 'o', chr(195).chr(180) => 'o',
               chr(195).chr(181) => 'o', chr(195).chr(182) => 'o',
               chr(195).chr(182) => 'o', chr(195).chr(185) => 'u',
               chr(195).chr(186) => 'u', chr(195).chr(187) => 'u',
               chr(195).chr(188) => 'u', chr(195).chr(189) => 'y',
               chr(195).chr(191) => 'y',
               // Decompositions for Latin Extended-A
               chr(196).chr(128) => 'A', chr(196).chr(129) => 'a',
               chr(196).chr(130) => 'A', chr(196).chr(131) => 'a',
               chr(196).chr(132) => 'A', chr(196).chr(133) => 'a',
               chr(196).chr(134) => 'C', chr(196).chr(135) => 'c',
               chr(196).chr(136) => 'C', chr(196).chr(137) => 'c',
               chr(196).chr(138) => 'C', chr(196).chr(139) => 'c',
               chr(196).chr(140) => 'C', chr(196).chr(141) => 'c',
               chr(196).chr(142) => 'D', chr(196).chr(143) => 'd',
               chr(196).chr(144) => 'D', chr(196).chr(145) => 'd',
               chr(196).chr(146) => 'E', chr(196).chr(147) => 'e',
               chr(196).chr(148) => 'E', chr(196).chr(149) => 'e',
               chr(196).chr(150) => 'E', chr(196).chr(151) => 'e',
               chr(196).chr(152) => 'E', chr(196).chr(153) => 'e',
               chr(196).chr(154) => 'E', chr(196).chr(155) => 'e',
               chr(196).chr(156) => 'G', chr(196).chr(157) => 'g',
               chr(196).chr(158) => 'G', chr(196).chr(159) => 'g',
               chr(196).chr(160) => 'G', chr(196).chr(161) => 'g',
               chr(196).chr(162) => 'G', chr(196).chr(163) => 'g',
               chr(196).chr(164) => 'H', chr(196).chr(165) => 'h',
               chr(196).chr(166) => 'H', chr(196).chr(167) => 'h',
               chr(196).chr(168) => 'I', chr(196).chr(169) => 'i',
               chr(196).chr(170) => 'I', chr(196).chr(171) => 'i',
               chr(196).chr(172) => 'I', chr(196).chr(173) => 'i',
               chr(196).chr(174) => 'I', chr(196).chr(175) => 'i',
               chr(196).chr(176) => 'I', chr(196).chr(177) => 'i',
               chr(196).chr(178) => 'IJ',chr(196).chr(179) => 'ij',
               chr(196).chr(180) => 'J', chr(196).chr(181) => 'j',
               chr(196).chr(182) => 'K', chr(196).chr(183) => 'k',
               chr(196).chr(184) => 'k', chr(196).chr(185) => 'L',
               chr(196).chr(186) => 'l', chr(196).chr(187) => 'L',
               chr(196).chr(188) => 'l', chr(196).chr(189) => 'L',
               chr(196).chr(190) => 'l', chr(196).chr(191) => 'L',
               chr(197).chr(128) => 'l', chr(197).chr(129) => 'L',
               chr(197).chr(130) => 'l', chr(197).chr(131) => 'N',
               chr(197).chr(132) => 'n', chr(197).chr(133) => 'N',
               chr(197).chr(134) => 'n', chr(197).chr(135) => 'N',
               chr(197).chr(136) => 'n', chr(197).chr(137) => 'N',
               chr(197).chr(138) => 'n', chr(197).chr(139) => 'N',
               chr(197).chr(140) => 'O', chr(197).chr(141) => 'o',
               chr(197).chr(142) => 'O', chr(197).chr(143) => 'o',
               chr(197).chr(144) => 'O', chr(197).chr(145) => 'o',
               chr(197).chr(146) => 'OE',chr(197).chr(147) => 'oe',
               chr(197).chr(148) => 'R',chr(197).chr(149) => 'r',
               chr(197).chr(150) => 'R',chr(197).chr(151) => 'r',
               chr(197).chr(152) => 'R',chr(197).chr(153) => 'r',
               chr(197).chr(154) => 'S',chr(197).chr(155) => 's',
               chr(197).chr(156) => 'S',chr(197).chr(157) => 's',
               chr(197).chr(158) => 'S',chr(197).chr(159) => 's',
               chr(197).chr(160) => 'S', chr(197).chr(161) => 's',
               chr(197).chr(162) => 'T', chr(197).chr(163) => 't',
               chr(197).chr(164) => 'T', chr(197).chr(165) => 't',
               chr(197).chr(166) => 'T', chr(197).chr(167) => 't',
               chr(197).chr(168) => 'U', chr(197).chr(169) => 'u',
               chr(197).chr(170) => 'U', chr(197).chr(171) => 'u',
               chr(197).chr(172) => 'U', chr(197).chr(173) => 'u',
               chr(197).chr(174) => 'U', chr(197).chr(175) => 'u',
               chr(197).chr(176) => 'U', chr(197).chr(177) => 'u',
               chr(197).chr(178) => 'U', chr(197).chr(179) => 'u',
               chr(197).chr(180) => 'W', chr(197).chr(181) => 'w',
               chr(197).chr(182) => 'Y', chr(197).chr(183) => 'y',
               chr(197).chr(184) => 'Y', chr(197).chr(185) => 'Z',
               chr(197).chr(186) => 'z', chr(197).chr(187) => 'Z',
               chr(197).chr(188) => 'z', chr(197).chr(189) => 'Z',
               chr(197).chr(190) => 'z', chr(197).chr(191) => 's',
               // Euro Sign
               chr(226).chr(130).chr(172) => 'E');

               $string = strtr($string, $chars);
       } 
       else 
       {
               // Assume ISO-8859-1 if not UTF-8
               $chars['in'] = chr(128).chr(131).chr(138).chr(142).chr(154).chr(158)
                       .chr(159).chr(162).chr(165).chr(181).chr(192).chr(193).chr(194)
                       .chr(195).chr(196).chr(197).chr(199).chr(200).chr(201).chr(202)
                       .chr(203).chr(204).chr(205).chr(206).chr(207).chr(209).chr(210)
                       .chr(211).chr(212).chr(213).chr(214).chr(216).chr(217).chr(218)
                       .chr(219).chr(220).chr(221).chr(224).chr(225).chr(226).chr(227)
                       .chr(228).chr(229).chr(231).chr(232).chr(233).chr(234).chr(235)
                       .chr(236).chr(237).chr(238).chr(239).chr(241).chr(242).chr(243)
                       .chr(244).chr(245).chr(246).chr(248).chr(249).chr(250).chr(251)
                       .chr(252).chr(253).chr(255);

               $chars['out'] = "EfSZszYcYuAAAAAACEEEEIIIINOOOOOOUUUUYaaaaaaceeeeiiiinoooooouuuuyy";

               $string = strtr($string, $chars['in'], $chars['out']);
               $double_chars['in'] = array(chr(140), chr(156), chr(198), chr(208), chr(222), chr(223), chr(230), chr(240), chr(254));
               $double_chars['out'] = array('OE', 'oe', 'AE', 'DH', 'TH', 'ss', 'ae', 'dh', 'th');
               $string = str_replace($double_chars['in'], $double_chars['out'], $string);
       }
       $string = str_replace(array('.', '’', '-', '_', '–'), array(' ', '', '', ' ', ''), $string);
       $string = preg_replace('/[[:punct:]]/', '', $string);
       $string = preg_replace('/[[:blank:]]/', '-', $string);
       $string = str_replace(array('--', '---', '----'), array('-', '-', '-'), $string);
       return strtolower($string);
	}
    
	function _seemsUtf8($Str) 
	{ 
      for ($i=0; $i<strlen($Str); $i++) 
      { 
           if (ord($Str[$i]) < 0x80) continue;
           elseif((ord($Str[$i]) & 0xE0) == 0xC0) $n=1; 
           elseif((ord($Str[$i]) & 0xF0) == 0xE0) $n=2; 
           elseif((ord($Str[$i]) & 0xF8) == 0xF0) $n=3;
           elseif((ord($Str[$i]) & 0xFC) == 0xF8) $n=4;
           elseif((ord($Str[$i]) & 0xFE) == 0xFC) $n=5;
           else return false; 
           for ($j=0; $j<$n; $j++) 
           { 
                if ((++$i == strlen($Str)) || ((ord($Str[$i]) & 0xC0) != 0x80)) 
                return false; 
           } 
      } 
      return true; 
	}
	
	function makeSafeEntities($str) 
	{
		return str_replace(array('&', '"', "'", '<', '>'), array ('&amp;' , '&quot;', '&#039;' , '&lt;' , '&gt;'), $str);
	}
}
?>
