<?php

/**
 * Controller :: Groups
 *
 * groups_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $11.02.2007$
 */

class GroupsController extends AppController
{
    var $name = 'Groups'; 
    
	function admin_index($page = 1) 
	{	
		$this->Auth->checkPermissions();	
		$paging =$this->Pager->getPagerData($this->Group->findCount(), $this->Pager->per_page, $page);
		$data = $this->Group->findAll("id <> '".ADMIN."' AND id <> '".USERS."'", "id, name, perm_type", "id DESC","".$paging->offset.", ".$paging->limit."");
		
		if(!$this->Session->check('parent'))
			@$this->Session->write('parent', strstr($_SERVER['HTTP_REFERER'], '/admin'));
		$this->_back('file_categories',$this->Session->read('parent'));
		
		$this->set('category','users');
		$this->set('data', $data);
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		
		$this->_sessionDel();
		
		$this->pageTitle = "Drumb - USER GROUPS";
		$this->render('admin', 'admin');
	}
	
	function admin_ban($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Group->setId($id);
		
		if ($this->Group->saveField('perm_type', 'deny')) 
		{
			$this->set('msg','The group was susccessfully banned!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The group was not banned!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_authorize($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Group->setId($id);
		
		if ($this->Group->saveField('perm_type', 'allow')) 
		{
			$this->set('msg','The group was susccessfully allowed!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The group was not allowed!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_add()
	{
		$this->Auth->checkPermissions();
		if($this->Group->save($this->data))
			$this->Session->write('msg','<p class="success">The group was susccessfully added!</p>');
		else
			$this->Session->write('msg','<p class="error">An error occured. The group was not added!</p>');
		
		$this->redirect('/admin/groups/');
	}

	function admin_edit($id = null)
	{
		$this->Auth->checkPermissions();
		if(($this->Group->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/groups/');
			exit();
		}
		
		$this->Group->setId($id);
		
		if (empty($this->data))
		{
			$this->_back('groups');
			
			$this->set('category','users');
			$this->set('data', $this->Group->read());
				
			$this->_sessionDel();
			
			$this->pageTitle = "Drumb - USER GROUPS";
			$this->render('edit', 'admin');
		}
		else
		{
			if ($this->Group->save($this->data))
				$this->Session->write('msg','<p class="success">The group was susccessfully changed!</p>');
			else
				$this->Session->write('msg','<p class="error">An error occured. The group was not changed!</p>');
			
			$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/admin').'#msg/');
		}
	}
	
	function admin_get_groups() 
	{
		$this->Auth->checkPermissions();
		if(isset($this->params['requested']))
			return $this->Group->findAll("id <> '".ADMIN."'", "id, name, perm_type");
	}
	
	function admin_is_group($id = null) 
	{
		$this->Auth->checkPermissions();
		if(isset($this->params['requested']))
		{
			if($this->Group->findCount("id = '".$id."'") > 0)
				return true;
			else
				return false;
		}
	}
}

?>
