<?php

/**
 * Controller :: Inquiries
 *
 * inquiries_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $03.02.2007$
 */

class InquiriesController extends AppController
{
    var $name = 'Inquiries';
	
    function admin_add()
	{
		$this->Auth->checkPermissions();
		if($this->Inquiry->save($this->data))
			$this->Session->write('msg','<p class="success">The inquiry was susccessfully added!</p>');
		else
			$this->Session->write('msg','<p class="error">An error occured. The inquiry was not added!</p>');
		
		$this->redirect('/admin/inquiries/');
	}
	
	function admin_index($page = 1) 
	{
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->Inquiry->findCount(), $this->Pager->per_page, $page);
		$data = $this->Inquiry->findAll(null, null, "published DESC, id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','inquiry');
		
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - INQUIRIES";
		$this->render('admin', 'admin');
	}
	
	function admin_edit($id = null)
	{
		$this->Auth->checkPermissions();
		if(($this->Inquiry->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/inquiries/');
			exit();
		}
		
		$this->Inquiry->setId($id);
		
		if (empty($this->data))
		{
			$this->_back('inquiries');
			$this->set('data', $this->Inquiry->read());
			$this->set('category','inquiry');
			
			$this->_sessionDel();
			
			$this->pageTitle = "Drumb - INQUIRIES";
			$this->render('edit', 'admin');
		}
		else
		{
			if ($this->Inquiry->save($this->data))
				$this->Session->write('msg','<p class="success">The inquiry was susccessfully changed!</p>');
			else
				$this->Session->write('msg','<p class="error">An error occured. The inquiry was not changed!</p>');
			
			$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/admin').'#msg/');
		}
	}
	
	function admin_unpublish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Inquiry->setId($id);
		
		if ($this->Inquiry->saveField('published', 'N')) 
		{
			$this->set('msg','The inquiry was susccessfully unpublished!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The inquiry was not unpublished!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_publish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Inquiry->setId($id);
		
		if ($this->Inquiry->saveField('published', 'Y')) 
		{
			$this->set('msg','The inquiry was susccessfully published!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The inquiry was not published!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if (is_array($this->Inquiry->del($id))) 
		{
			$this->set('msg','The inquiry was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The inquiry was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function get_all($id = '', $name = '') 
	{
		if(isset($this->params['requested']))
			return $this->Inquiry->findAll("published = 'Y'", "question, id", "created DESC");;
	}
	
	function index($id = '', $name = '') 
	{
		if($name != '' && $id != '')
			$data = $this->Inquiry->find("published = 'Y' AND id = '".$id."'", "question, id");
		else 
    {
			$data = $this->Inquiry->find("published = 'Y'", "question, id", "created DESC");
		  $id = $data['Inquiry']['id'];
    }
		if(isset($this->params['requested']))
			return $data;
		$count = $this->requestAction('/inquiry_answers/'.$id.'/');
		$this->set('count', count($count));
    $this->set('data', $data);		
		$this->pageTitle = "INQURIES, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('index', 'user');		
	}
	
	function has_voted($id = null)
	{
		if($this->Inquiry->findCount("id = '".$id."' AND dnb_user_ids LIKE '%[".$this->Auth->getUserId()."]%'") > 0 || $id == null)
			return true;
		else
		{
			$this->Inquiry->update($id, $this->Auth->getUserId());
			return false;
		}
	}
}

?>
