<?php

/**
 * Controller :: InquiryAnswers
 *
 * inquiries_answer_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $03.02.2007$
 */

class InquiryAnswersController extends AppController
{
    var $name = 'InquiryAnswers';
    
	function admin_add()
	{
		$this->Auth->checkPermissions();
		if($this->InquiryAnswer->save($this->data))
			$this->Session->write('msg','<p class="success">The answer was susccessfully added!</p>');
		else
			$this->Session->write('msg','<p class="error">An error occured. The answer was not added!</p>');
		$this->redirect('/admin/inquiry_answers/1/'.$this->data['InquiryAnswer']['dnb_inquiry_id'].'/');
	}
	
	function admin_index($page = 1, $category_id = null) 
	{
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->InquiryAnswer->findCount("dnb_inquiry_id='".$category_id."'"), $this->Pager->per_page, $page);
		$data = $this->InquiryAnswer->findAll("dnb_inquiry_id='".$category_id."'", null, "id ASC","".$paging->offset.", ".$paging->limit."");
		
		if(!$this->Session->check('parent'))
			@$this->Session->write('parent', strstr($_SERVER['HTTP_REFERER'], '/admin'));
		$this->_back('inquirys',$this->Session->read('parent'));
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','inquiry');
		$this->set('category_id',$category_id);
		
		$this->_sessionDel();
		
		$this->pageTitle = "Drumb - INQUIRIE ANSWERS";
		$this->render('admin', 'admin');
	}
	
	function admin_edit($id = null, $category_id = null)
	{
		$this->Auth->checkPermissions();
		if(($this->InquiryAnswer->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/inquiry_answers/1/'.$category_id.'/');
			exit();
		}
		
		$this->InquiryAnswer->setId($id);
		
		if (empty($this->data))
		{
			$this->_back('inquiry_answers/1/'.$category_id);
			
			$this->set('data', $this->InquiryAnswer->read());
			$this->set('category_id', $category_id);
			$this->set('category','links');
			
			$this->_sessionDel();
			
			$this->pageTitle = "Drumb - INQUIRIE ANSWERS";
			$this->render('edit', 'admin');
		}
		else
		{
			if($this->InquiryAnswer->save($this->data))
				$this->Session->write('msg','<p class="success">The answer was susccessfully changed!</p>');
			else
				$this->Session->write('msg','<p class="error">An error occured. The answer was not changed!</p>');
			
			$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/admin').'#msg/');
		}
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if($this->InquiryAnswer->del($id)) 
		{
			$this->set('msg','The answer was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The answer was not deleted!');
			$this->set('flag','error');
		}
		
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}

	function index($id = null) 
	{
		if(isset($this->params['requested']) && $id != null)
			return $this->InquiryAnswer->findAll("dnb_inquiry_id = '".$id."'", "id, answer", "answer ASC");
		elseif($id != null)
		{ 
			$this->set('data', $this->InquiryAnswer->findAll("dnb_inquiry_id = '".$id."'", "count, answer", "answer ASC"));
			$this->render('chart', 'clean');
		}
	}
	
	function vote($answer_id = null, $inquiry_id = null, $ajax = null) 
	{
		if($answer_id == null || $inquiry_id == null || !isset($_SERVER['HTTP_REFERER']))
		{
			$this->redirect('/error404/');
			exit();
		}
		
		if(!$this->Auth->validate()) 
		{
			if($ajax != null) 
			{
				$this->set('msg','You must by logged in to vote!');
				$this->set('flag','info inquiry_message_ajax');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			}
			else
			{
				$this->Session->write('msg_form','<p class="info inquiry_message">You must by logged in to vote!</p>');
				$this->redirect('/artists/'.$id.'/'.$name.'/#msg_form');
			}
			exit();
		}
		
		if(!$this->Auth->validate())
		{
			if($ajax != null) 
			{
				$this->set('msg','You must be loged in, to vote!');
				$this->set('flag','info inquiry_message_ajax');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			}
			else
			{
				$this->Session->write('msg_inquiry','<p class="info inquiry_message">You must be loged in, to vote!</p>');
				$this->redirect($_SERVER['HTTP_REFERER'].'#msg_inquiry');
			}
			exit();
		}
		
		if($this->requestAction('/inquiries/has_voted/'.$inquiry_id.'/') == true)
		{
			if($ajax != null) 
			{
				$this->set('msg','You have allready voted in this inquiry!');
				$this->set('flag','error inquiry_message_ajax');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			}
			else
			{
				$this->Session->write('msg_inquiry','<p class="error inquiry_message">You have allready voted in this inquiry!</p>');
				$this->redirect($_SERVER['HTTP_REFERER'].'#msg_inquiry');
			}
			exit();
		}
		
		if($this->InquiryAnswer->vote($answer_id)) 
		{
			if($ajax != null) 
			{
				$this->set('msg','Your vote was susccessfully saved!');
				$this->set('flag','tick inquiry_message_ajax');
			}
			else
				$this->Session->write('msg_inquiry','<p class="tick inquiry_message">Your vote was susccessfully saved!</p>');
		}
		else 
		{
			if($ajax != null) 
			{
				$this->set('msg','An error occured. Your vote was not saved!!');
				$this->set('flag','error inquiry_message_ajax');
			}
			else
				$this->Session->write('msg_inquiry','<p class="error inquiry_message">An error occured. Your vote was not saved!</p>');
		}
		if($ajax != null) 
			$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
		else
			$this->redirect($_SERVER['HTTP_REFERER'].'#msg_inquiry');
	}
}

?>
