<?php

/**
 * Controller :: NewsCategories
 *
 * news_categories_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $05.02.2007$
 */

class NewsCategoriesController extends AppController
{
    var $name = 'NewsCategories';
    
	function admin_index($page = 1) 
	{	
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->NewsCategory->findCount(), $this->Pager->per_page, $page);
		$data = $this->NewsCategory->findAll(null, 'id,name,color', "id DESC","".$paging->offset.", ".$paging->limit."");
		
		if(!$this->Session->check('parent'))
			@$this->Session->write('parent', strstr($_SERVER['HTTP_REFERER'], '/admin'));
		$this->_back('news',$this->Session->read('parent'));
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','news');
		
		$this->_sessionDel();

		$this->pageTitle = "Drumb - NEWS CATEGORIES";
		$this->render('admin', 'admin');
	}
	
	function admin_color($id = null, $color = 'FFFFFF')
	{	
		$this->Auth->checkPermissions();
		$this->NewsCategory->setId($id);
		
		if ($this->NewsCategory->saveField('color', $color)) 
		{
			$this->set('msg','The color was susccessfully changed!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The color was not changed!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_add()
	{
		$this->Auth->checkPermissions();
		if($this->NewsCategory->save($this->data))
			$this->Session->write('msg','<p class="success">The news category was susccessfully added!</p>');
		else
			$this->Session->write('msg','<p class="error">An error occured. The news category was not added!</p>');
		$this->redirect('/admin/news_categories/');
	}
	
	function admin_edit($id = null)
	{	
		$this->Auth->checkPermissions();
		if(($this->NewsCategory->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/news_categories/');
			exit();
		}
		
		$this->NewsCategory->setId($id);
		
		if(empty($this->data))
		{
			$this->_back('news_categories');
			
			$this->set('data', $this->NewsCategory->read());
			$this->set('category','news');
			
			$this->_sessionDel();
			
			$this->pageTitle = "Drumb - NEWS CATEGORIES";
			$this->render('edit', 'admin');
		}
		else
		{
			if ($this->NewsCategory->save($this->data))
				$this->Session->write('msg','<p class="success">The news category was susccessfully changed!</p>');
			else
				$this->Session->write('msg','<p class="error">An error occured. The news category was not changed!</p>');
			
			$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/admin').'#msg/');
		}
	}
	
	function admin_get_news_categories() 
	{
		$this->Auth->checkPermissions();
		if(isset($this->params['requested']))
			return $this->NewsCategory->findAll(null, "id, name", "id DESC");
	}
}

?>