<?php

/**
 * Controller :: News
 *
 * news_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $05.02.2007$
 */

class NewsController extends AppController
{
    var $name = 'News';
    
	function admin_unpublish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->News->setId($id);
		if ($this->News->saveField('published', 'N')) 
		{
			$this->set('msg','The news was susccessfully unpublished!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The news was not unpublished!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_publish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->News->setId($id);
		
		if ($this->News->saveField('published', 'Y')) 
		{
			$this->set('msg','The news was susccessfully published!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The news was not published!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if ($this->News->del($id)) 
		{
			$dir = WWW_ROOT . "upload" . DS . "news" . DS . $id . DS;
			$this->Filemanager->deleteDir($dir);
			$this->News->delComments('news', $id);
			
			$this->set('msg','The news was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The news was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_index($page = 1) 
	{				
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->News->findCount(), $this->Pager->per_page, $page);
		$data = $this->News->table($paging->offset, $paging->limit);
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','news');

		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - NEWS";
		$this->render('admin', 'admin');
	}
	
	function admin_filter() 
	{
		$this->Auth->checkPermissions();
		
		$paging =$this->Pager->getPagerData($this->News->findCount("header LIKE '%".$_GET['filter']."%'"), $this->Pager->per_page, $_GET['page']);
		$data = $this->News->table($paging->offset, $paging->limit, $_GET['filter']);
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','news');
		$this->set('filter', $_GET['filter']);
		
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - NEWS";
		$this->render('admin', 'admin');
	}
	
	function admin_add() 
	{
		$this->Auth->checkPermissions();
		$this->_back('news','/admin/news/');	
		
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
		$js .= '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
		$categories = $this->requestAction('/admin/news_categories/get_news_categories/');
		
		$this->set('css', $css);
		$this->set('js', $js);
		$this->set('category','news');
		$this->set('data', $this->Session->read('data'));
		$this->set('files',  $this->Session->read('files'));
		$this->set('categories',  $categories);
		
		if(is_file($this->Session->read('dir').'perex.jpg'))
			$this->set('perex',  $this->webroot.strstr($this->Filemanager->htmlPath($this->Session->read('dir')).'perex.jpg','upload'));
		else 
			$this->set('perex', $this->webroot.'upload/news/perex.gif');
		
		$this->Session->del('data');
		$this->pageTitle = "Drumb - NEWS";
		$this->render('add', 'admin');
	}
	
	function admin_save()
	{
		$this->Auth->checkPermissions();
		@$this->Session->write('redirect', strstr($_SERVER['HTTP_REFERER'], '/admin'));	
		
		if($this->Session->check('id') && empty($this->data['News']['id'])) 
		{
			$this->data['News']['id'] = $this->Session->read('id');
			$this->News->setId($this->data['News']['id']);
		} 
		else 
			$this->News->setId($this->data['News']['id']);
		
		if($this->News->save($this->data)) 
		{
			if(!$this->Session->check('id') && empty($this->data['News']['id'])) 
			{
				$this->Session->write('id' ,mysql_insert_id());
				$this->data['News']['id'] = $this->Session->read('id');
			}
			
			$dir = WWW_ROOT . "upload" . DS . "news" . DS . $this->data['News']['id'] . DS; 
			$this->Filemanager->createDir($dir);
			$this->Session->write('msg','<p class="success">The news was susccessfully saved!</p>');
		}
		else
			$this->Session->write('msg','<p class="error">A error occured. The news was not saved!</p>');
		
		$this->Session->write('data',$this->data);
		
		if(isset($this->data['News']['upload'])) 
		{
			if(($origin = $this->Filemanager->upload($_FILES['file'], $dir, array('jpg', 'gif', 'jpeg', 'txt', 'doc', 'pdf', 'xls', 'mp3'), 8000000))) 
			{
				$this->Session->write('msg','<p class="success">The file was susccessfully uploaded!</p>');
				$type = pathinfo($origin, PATHINFO_EXTENSION);
				if($type == 'jpg' || $type == 'jpeg' || $type == 'gif') 
				{
					$image = getimagesize($origin);
					if($image[0] > 400)
					{
						$ratio = ($image[0] / $image[1]);
						$image[0] = 400;
						$image[1] =	(400 / $ratio);
						$this->Filemanager->imgResize($origin,$origin,$image[0],$image[1]);
					}	
				}
			}
			@$this->Filemanager->deleteFile($dir.'perex_temp.jpg');
			$this->Session->write('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
			$this->redirect($this->Session->read('redirect'));
			exit();
		} 
		elseif(isset($this->data['News']['perex']))
		{
			if(($dest = $this->Filemanager->upload($_FILES['perex'], $dir, array('jpg', 'gif', 'jpeg'), 8000000, 'perex_temp.jpg'))) 
			{				
				$this->Session->write('dest', $dest);
				$this->Session->write('dir', $dir);
				$this->redirect('/admin/news/perex/');
			} 
			else
				$this->redirect($this->Session->read('redirect'));
			exit();	
		} 
		else
			$this->redirect($this->Session->read('redirect'));
	}
	
	function admin_perex($action = null) 
	{
		$this->Auth->checkPermissions();
		$dest = $this->webroot.strstr($this->Filemanager->htmlPath($this->Session->read('dest')),'upload');
		$full_dest = $this->Session->read('dest');
		
		if($action == 'crop')
		{
			if($this->Filemanager->imgCrop($full_dest,$full_dest,$this->data['News']['x'], $this->data['News']['y'], $this->data['News']['width'], $this->data['News']['height'])) 
			{
				if($this->Filemanager->imgResize($full_dest,$this->Session->read('dir').'perex.jpg',100,100)) 
				{
					$this->Filemanager->deleteFile($full_dest);
					$this->Session->write('files',  $this->Filemanager->searchDir($this->Session->read('dir'),0,'FILES'));
					$this->Session->write('msg','<p class="success">Perex was susccessfully croped!</p>');
					$this->Session->del('dest');
				}
			} 
			else
				$this->Session->write('msg','<p class="error">A error occured. The Perex was not croped!</p>');
			
			$this->redirect($this->Session->read('redirect').'');
			exit();
		}
		
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/interface/croper.php" />';
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/interface/interface.php"></script>';
		$image = getimagesize($this->Session->read('dest'));
		
		if($image[0] > 800) 
		{ 
			$ratio = ($image[0] / $image[1]);
			$image[0] = 800;
			$image[1] =	(800 / $ratio);
			$this->Filemanager->imgResize($full_dest,$full_dest,$image[0],$image[1]);
		}
		
		$this->set('width', $image[0]);
		$this->set('height', $image[1]);
		$this->set('css', $css);
		$this->set('js', $js);
		$this->set('category','news');
		$this->set('dest', $dest);
		
		$this->pageTitle = "Drumb - PEREX CROP";
		$this->render('crop', 'admin');
	}

	function admin_delete_file()
	{	
		$this->Auth->checkPermissions();
		$dir = WWW_ROOT . "upload" . DS . "news" . DS . $_POST['id'] . DS . $_POST['name'];
		if($this->Filemanager->deleteFile($dir)) 
		{
			$this->set('msg','The file was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','A error occured. The file was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}

	function admin_edit($id = null)
	{
		$this->Auth->checkPermissions();
		if(($this->News->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/news/');
			exit();
		}
		
		$this->News->setId($id);
		
		if(!$this->Session->check('data'))
			$data = $this->News->read();
		else 
		{
			$data = $this->Session->read('data');
			$this->Session->del('data');
		}
		
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
		$js .= '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
		$categories = $this->requestAction('/admin/news_categories/get_news_categories/');
		$dir = WWW_ROOT . "upload" . DS . "news" . DS . $data['News']['id'] . DS;
		@$this->Filemanager->deleteFile($dir.'perex_temp.jpg');
		$this->_back('news');
		
		$this->set('data', $data);
		$this->set('css', $css);
		$this->set('js', $js);
		$this->set('category','news');
		$this->set('categories',  $categories);
		$this->set('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
		
		if(is_file($dir.'perex.jpg'))
			$this->set('perex', $this->webroot.strstr($this->Filemanager->htmlPath($dir).'perex.jpg','upload'));
		else
			$this->set('perex', $this->webroot.'upload/news/perex.gif');
			
		$this->pageTitle = "Drumb - NEWS";
		$this->render('edit', 'admin');
	}
	
	function news($page = 1) 
	{
		$this->Pager->per_page = 14;
		$paging = $this->Pager->getPagerData($this->News->findCount("published = 'Y' AND CURDATE() >= publish_date"), $this->Pager->per_page, $page);
		
		if($page > $paging->numPages) 
		{
			$this->redirect('/error404/');
			exit();	
		}
	
		$data = $this->News->newsList($paging->offset, $paging->limit);
		
		$data['page'] = $paging->page;
		$data['numPages'] = $paging->numPages;
		$data['date'] = $data[0]['dnb_news']['publish_date'];
		
		$this->set('data', $data);
		
		$this->pageTitle = "NEWS, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('news', 'user');		
	}
	
	function get_older_news($offset = null, $limit = null)
	{
		if($offset == null || $limit == null)
		{
			$this->redirect('/error404/');
			exit();	
		}
		if(isset($this->params['requested']))
			return $this->News->newsList($offset, $limit);
	}
	
	function get_news($type = null)
	{
		if(isset($this->params['requested']) && $type == "radiofm") 
		{
			$radio_fm = $this->News->find("published = 'Y' AND CURDATE() >= publish_date AND dnb_news_category_id = '".RADIO_FM."'" ,'id, header', 'publish_date DESC');
			if(empty($radio_fm))
				return false;
			else
				return '/news/'.$radio_fm['News']['id'].'/'.$this->Filemanager->removeAccents($radio_fm['News']['header']).'/';
		}
		
		if(isset($this->params['requested']) && ($type == "comments" || $type == "popularity")) 
		{
			return $this->News->findAll("published = 'Y' AND CURDATE() >= publish_date AND DATE_SUB(CURDATE(), INTERVAL 7 DAY) <= publish_date",'id, header, comments, popularity',  $type.' DESC', 7);
		}
	}
	
	function quick($type = null, $ajax = null)
	{
		if($type != null) 
		{
			if($type == "listen")
				$data = $this->News->findAll("published = 'Y' AND CURDATE() >= publish_date AND dnb_news_category_id = '".LISTEN."'",'id, header, publish_date', 'publish_date DESC', 5);
			else 
				$data = $this->News->findAll("published = 'Y' AND CURDATE() >= publish_date AND recommended = 'Y'",'id, header, publish_date', 'publish_date DESC', 5);
			if($ajax != null)
			{
				$this->set('news', $data);	
				$this->render('quick', 'clean');
			}
			else
				return $data;
		}
	}
	
	function get_by_tag($tag = null)
	{
		if($tag != null && isset($this->params['requested'])) 
			return $this->News->getNews(null, $tag);
	}
	
	function index($id = null, $name = null, $page = 1) 
	{	
		if($id == null || $name == null)
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$this->News->updatePopularity($id, '+');
		$data = array_pop($this->News->getNews($id));
		
		if(empty($data)) 
		{
			$this->redirect('/error404/');
			exit();
		}

		$news = $this->requestAction('/news/get_by_tag/'.$data['dnb_news']['tag'].'/');
		$parties = $this->requestAction('/parties/get_by_tag/'.$data['dnb_news']['tag'].'/');
		$photo_galleries = $this->requestAction('/photo_galleries/get_by_tag/'.$data['dnb_news']['tag'].'/');
		$competitions = $this->requestAction('/competitions/get_by_tag/'.$data['dnb_news']['tag'].'/');
		
		$related = array();
		
		if(!empty($news))
		{
			foreach($news as $item) 
			{
				if($item['dnb_news']['header'] == $data['dnb_news']['header'] && $data['dnb_news']['id'] == $item['dnb_news']['id'])
					continue;
				$related[] = array('cat' => 'news', 'header' => $item['dnb_news']['header'], 'id' => $item['dnb_news']['id'], 'views' => $item['dnb_news']['popularity'], 'comments' => $item['dnb_news']['comments'], 'publish_date' => $item['dnb_news']['publish_date'], 'color' => $item['dnb_news_categories']['color'], 'category' => $item['dnb_news_categories']['name'], 'user' => $item['dnb_users']['username']);
			}		
		}
		if(!empty($photo_galleries))
		{
			foreach($photo_galleries as $item) 
			{
				$photo = $this->Filemanager->searchDir(WWW_ROOT . 'upload' . DS . 'photos' . DS . $item['PhotoGallery']['id'] . DS,0,'FILES',0,0,1);
				$related[] = array('cat' => 'photos', 'path' => $photo[0]['File']['path'], 'cor' => $this->Filemanager->squareImg($photo[0]['File']['path']), 'header' => $item['PhotoGallery']['header'], 'id' => $item['PhotoGallery']['id'], 'views' => $item['PhotoGallery']['popularity'], 'comments' => $item['PhotoGallery']['comments'], 'date' => $item['PhotoGallery']['date'], 'city' => $item['PhotoGallery']['city'], 'club' => $item['PhotoGallery']['club'], 'user' => $item['PhotoGallery']['authors']);
			}
		}
		if(!empty($parties))
		{
			foreach($parties as $item) 
				$related[] = array('cat' => 'parties', 'header' => $item['Party']['name'], 'id' => $item['Party']['id'], 'views' => $item['Party']['popularity'], 'comments' => $item['Party']['comments'], 'date' => $item['Party']['date'], 'city' => $item['Party']['city'], 'club' => $item['Party']['club'], 'state' => $item['Party']['state']);
		}
		if(!empty($competitions))
		{
			foreach($competitions as $item) 
				$related[] = array('cat' => 'competitions', 'header' => $item['Competition']['header'], 'id' => $item['Competition']['id'], 'views' => $item['Competition']['popularity'], 'from_date' => $item['Competition']['from_date'], 'to_date' => $item['Competition']['to_date']);
		}
		$this->set('data', $data);
		$this->set('related', $related);
		$this->set('page', $page);
		
		$this->pageTitle = "NEWS - ".$data['dnb_news']['header'].", dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('index', 'user');
	}
	
	function rate($stars = null, $id = null, $name = null, $ajax = null)
	{
		if($stars == null || $id == null || $name == null || !isset($_SERVER['HTTP_REFERER'])) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		if(!$this->Auth->validate()) 
		{
			if($ajax != null) 
			{
				$this->set('msg','You must by logged in, to rate a news!');
				$this->set('flag','info_big');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			}
			else
			{
				$this->Session->write('msg_form','<p class="info_big">You must by logged in, to rate a news!</p>');
				$this->redirect('/news/'.$id.'/'.$name.'/#msg_form');
			}
			exit();
		}
		
		if($this->News->findCount("id = '".$id."' AND dnb_user_ids LIKE '%[".$this->Auth->getUserId()."]%'") > 0) 
		{
			if($ajax != null) 
			{
				$this->set('msg','You have allready rated this news!');
				$this->set('flag','error_big');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			}
			else
			{
				$this->Session->write('msg_form','<p class="error_big">You have allready rated this news!</p>');
				$this->redirect('/news/'.$id.'/'.$name.'/#msg_form');
			}
			exit();
		}
		else
		{
			$this->News->update($id, $this->Auth->getUserId(), $stars);
			if($ajax != null) 
			{
				$this->set('msg','Your rating was susccessfully saved!');
				$this->set('flag','tick_big');
			}
			else
				$this->Session->write('msg_form','<p class="tick_big">Your rating was susccessfully saved!</p>');
		}
		if($ajax != null) 
			$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
		else
			$this->redirect('/news/'.$id.'/'.$name.'/#msg_form');
	}
}

?>
