<?php

/**
 * Controller :: Pages
 *
 * pages_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $03.02.2007$
 */

class PagesController extends AppController
{
    var $name = 'Pages';
	
	function admin_index()
	{
		$this->pageTitle = "Drumb - LOGIN";
		$this->set('category','');
		$this->render('login', 'login');	
	}
	
    function admin_welcome()
	{
		$this->Auth->checkPermissions();
		$this->pageTitle = "Drumb - WELCOME";
		$this->set('category','');
		$this->render('welcome', 'admin');	
	}
	
	function admin_page_preview()
	{
		$js =  '<script language="javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_popup.js"></script>';
		$js .= '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/plugins/preview/jscripts/embed.js"></script>';	
		$this->set('js', $js);
		$this->pageTitle = "Drumb - PAGE PREVIEW";
		$this->render('page_preview', 'user');
	}
	
	function admin_pages($page = 1)
	{
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->Page->findCount("parent_id = '0'"), $this->Pager->per_page, $page);
		$data = $this->Page->findAll("parent_id = '0'", "id, menu_name, published", "published DESC,id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category', 'pages');
		$this->set('header', 'Pages');
		$this->set('form_class', 'comments_form');
		$this->set('parent_id', 0);
		
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - PAGES";
		$this->render('pages', 'admin');
	}
	
	function admin_no_permissions()
	{
		if($this->Auth->getUserGroupId() == USERS || !$this->Auth->validate()) 
		{
			$this->redirect('/news/');
			exit();
		}
		
		$this->pageTitle = "Drumb - NO PERMISSIONS";
		$this->set('category','');
		$this->render('no_permissions', 'admin');
	}
	
	function admin_subpages($page = 1, $parent_id = 0)
	{
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->Page->findCount("parent_id = '".$parent_id."'"), $this->Pager->per_page, $page);
		$data = $this->Page->findAll("parent_id = '".$parent_id."'", "id, menu_name, published", "published DESC, id DESC","".$paging->offset.", ".$paging->limit."");
		
		if(!$this->Session->check('parent'))
			@$this->Session->write('parent', strstr($_SERVER['HTTP_REFERER'], '/admin'));
		$this->_back('pages',$this->Session->read('parent'));
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category', 'pages');
		$this->set('header', 'Subpages');
		$this->set('form_class', 'small_form');
		$this->set('parent_id',$parent_id);
		
		$this->_sessionDel();
		
		$this->pageTitle = "Drumb - SUBPAGES";
		$this->render('pages', 'admin');
	}
	
	function admin_add()
	{
		$this->Auth->checkPermissions();
		$this->data['Page']['header'] = $this->data['Page']['menu_name'];
		
		if($this->Page->save($this->data))
			$this->Session->write('msg','<p class="success">The page was susccessfully added!</p>');
		else
			$this->Session->write('msg','<p class="error">An error occured. The page was not added!</p>');
		
		if($this->data['Page']['parent_id'] != 0)
			$this->redirect('/admin/subpages/1/'.$this->data['Page']['parent_id'].'/');
		else	
			$this->redirect('/admin/pages/');
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if(($this->Page->findCount("parent_id='".$id."'")) > 0) 
		{
			$this->set('msg','The page was not deleted! You must delele all its subpages');
			$this->set('flag','error');
			
			$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			exit();
		}
		
		if ($this->Page->del($id)) 
		{
			$dir = WWW_ROOT . "upload" . DS . "pages" . DS . $id . DS;
			@$this->Filemanager->deleteDir($dir);
			$this->set('msg','The page was susccessfully deleted!');
			$this->set('flag','success');	
		}
		else 
		{
			$this->set('msg','An error occured. The page was not deleted!');
			$this->set('flag','error');
		}
		
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_unpublish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Page->setId($id);
		
		if ($this->Page->saveField('published', 'N')) 
		{
			$this->set('msg','The page was susccessfully unpublished!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The page was not unpublished!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_publish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Page->setId($id);
		
		if ($this->Page->saveField('published', 'Y')) 
		{
			$this->set('msg','The page was susccessfully published!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The page was not published!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
 	function admin_edit($id = null) 
 	{
 		$this->Auth->checkPermissions();
 		if(($this->Page->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/pages_content/');
			exit();
		}
		
		$this->Page->setId($id);
		
		if(!$this->Session->check('data')) 
			$data = $this->Page->read();
		
		else
			$data = $this->Session->read('data');
		
		$this->Session->del('data');
		
		$dir = WWW_ROOT . "upload" . DS . "pages" . DS . $data['Page']['id'] . DS;
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
		$this->_back('content_pages');
		$this->Filemanager->createDir($dir);
				
		$this->set('data', $data);
		$this->set('js', $js);
		
		$this->set('category','pages_content');
		$this->set('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
		
		$this->pageTitle = "Drumb - PAGES CONTENT";
		$this->render('content_edit', 'admin');
 	}
	
	function admin_save()
	{
		$this->Auth->checkPermissions();
		@$this->Session->write('redirect', strstr($_SERVER['HTTP_REFERER'], '/admin'));	
		
		if($this->Session->check('id') && empty($this->data['Competition']['id'])) 
		{
			$this->data['Page']['id'] = $this->Session->read('id');
			$this->Page->setId($this->data['Page']['id']);
		}
		else 
			$this->Page->setId($this->data['Page']['id']);
		
		if($this->Page->save($this->data)) 
		{
			if(!$this->Session->check('id') && empty($this->data['Page']['id'])) 
			{
				$this->Session->write('id' ,mysql_insert_id());
				$this->data['Page']['id'] = $this->Session->read('id');
			}
			
			$dir = WWW_ROOT . "upload" . DS . "pages" . DS . $this->data['Page']['id'] . DS; 
			$this->Filemanager->createDir($dir);
			$this->Session->write('msg','<p class="success">The page content was susccessfully saved!</p>');
		}
		else
			$this->Session->write('msg','<p class="error">An error occured. The page content was not saved!</p>');
		
		$this->Session->write('data',$this->data);
		
		if(isset($this->data['Page']['upload'])) 
		{
			if(($origin = $this->Filemanager->upload($_FILES['file'], $dir, array('jpg', 'gif', 'jpeg', 'txt', 'doc', 'pdf', 'xls', 'mp3'), 8000000))) 
			{
				$this->Session->write('msg','<p class="success">The file was susccessfully uploaded!</p>');
				$type = pathinfo($origin, PATHINFO_EXTENSION);
				if($type == 'jpg' || $type == 'jpeg' || $type == 'gif')
				{
					$image = getimagesize($origin);
					if($image[0] > 400)
					{
						$ratio = ($image[0] / $image[1]);
						$image[0] = 400;
						$image[1] =	(400 / $ratio);
						$this->Filemanager->imgResize($origin,$origin,$image[0],$image[1]);
					}
						
				}
			}
			$this->Session->write('files',  $this->Filemanager->searchDir($dir,0,'FILES'));
			$this->redirect($this->Session->read('redirect'));
			exit();
		} 
		else 
			$this->redirect($this->Session->read('redirect'));
	}
	
	function admin_filter($filter = null, $page = 1) 
	{
		$this->Auth->checkPermissions();
		if(!empty($this->data)) 
		{
			$filter = $this->data['Page']['filter'];
			$this->redirect($this->params['url']['url'].$filter.'/'.$page.'/');
			exit();
		}
		
		$pages = $this->Page->findAll(null, null, "published DESC,id DESC");
		$pages_by_filter = $this->Page->findAll("menu_name LIKE '%".$filter."%'", 'published, menu_name, id, parent_id', "published DESC, id DESC");
		$data = array();
		
		foreach ($pages_by_filter as $entry) 
		{
			$parent = false;
			foreach ($pages as $subpage) 
			{
				if($entry['Page']['id'] == $subpage['Page']['parent_id']) 
					$parent = true;
			}
			if(!$parent) 
				array_push($data, $entry['Page']);
		}

		$paging = $this->Pager->getPagerData(count($data), $this->Pager->per_page, $page);

		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('per_page', $this->Pager->per_page);
		$this->set('data', $data);
		$this->set('filter', $filter);
		$this->set('category','pages_content');

		$this->_sessionDel();
		
		$this->pageTitle = "Drumb - PAGES CONTENT";
		$this->render('pages_content', 'admin');
	}
	
	function admin_delete_file()
	{	
		$this->Auth->checkPermissions();
		$dir = WWW_ROOT . "upload" . DS . "pages" . DS . $_POST['id'] . DS . $_POST['name'];
		if($this->Filemanager->deleteFile($dir)) 
		{
			$this->set('msg','The file was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The file was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function search() 
	{
	    $_GET['filter'] = strip_tags($_GET['filter']);
		$data = $this->Page->search($_GET['filter']);

		$this->set('data', $data);
		$this->set('filter', $_GET['filter']);
		$this->set('category','');
		
		$this->pageTitle = "SEARCH RESULTS, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('search', 'user');
	}

	function error404() 
	{
		$this->pageTitle = "ERROR 404 - NOT FOUND, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('error404', 'user');		
	}
	
	function get_menu() 
	{	
		if(isset($this->params['requested']))
			return $this->Page->findAll(null, 'header, id, menu_name, parent_id', "header ASC");
	}
	
	function index($id = null, $name = null) 
	{
		
		if($id == null || $name == null)
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$data = $this->Page->find("published = 'Y' AND id ='".$id."'",'header, content, parent_id, type, id');
		
		if(empty($data)) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$parent = $this->Page->find("published = 'Y' AND id ='".$data['Page']['parent_id']."'",'menu_name');
		
		if(empty($parent))
			$this->set('header', $data['Page']['header']);
		else
			$this->set('header', $parent['Page']['menu_name']);

		$this->set('data', $data);
		
		$this->pageTitle = strtoupper($data['Page']['header']).", dnb.sk - Slovak and World drum &amp; bass scene";
		
		if($data['Page']['type'] == 'simple') 
			$this->render('simple', 'user');
		else 
		{
			$js = '<script type="text/javascript" src="'.$this->webroot.'js/lightbox/spica.php">';
			$js .= '</script><script type="text/javascript" src="'.$this->webroot.'js/lightbox/lightbox_plus.php"></script>';
			$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/lightbox/lightbox.php" />';
			
			$this->set('css', $css);
			$this->set('js', $js);
			
			$this->render('advanced', 'user');
		}
	}
	
	function captcha() 
	{
		if(isset($this->params['requested']))
		{
			$first = (rand(0, 10));
			$second = (rand(0, 10));
			$operator = (rand(1, 2));
			
			if($operator == 1)
			{
				$operator = '+';
				$this->Session->write('captcha', ($first + $second));
			}
			else
			{
				$operator = 'x';
				$this->Session->write('captcha', ($first * $second));
			}
			return 'How much is '.$first.' '.$operator.' '.$second.'?';
		}
	}
}

?>
