<?php

/**
 * Controller :: PhotoGalleries
 *
 * photo_galeries_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $03.02.2007$
 */ 

class PhotoGalleriesController extends AppController
{
    var $name = 'PhotoGalleries';
    
	function admin_unpublish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->PhotoGallery->setId($id);
		
		if ($this->PhotoGallery->saveField('published', 'N')) 
		{
			$this->set('msg','The photo gallery was susccessfully unpublished!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The photo gallery was not unpublished!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_publish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->PhotoGallery->setId($id);
		
		if($this->PhotoGallery->saveField('published', 'Y'))
		{
			$this->set('msg','The photo gallery was susccessfully published!');
			$this->set('flag','success');
		}
		else
		{
			$this->set('msg','An error occured. The photo gallery was not published!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
    function admin_save()
	{
		$this->Auth->checkPermissions();
		if($this->PhotoGallery->save($this->data)) 
		{
			$this->PhotoGallery->setId($this->data['PhotoGallery']['id']);
			$dir = WWW_ROOT . "upload" . DS . "photos" . DS . mysql_insert_id() . DS;
			$this->Filemanager->createDir($dir);
			
			if($this->data['PhotoGallery']['id'] == '')
				$this->data['PhotoGallery']['id'] = mysql_insert_id();
			
			$this->Session->write('data', $this->data);
			$this->Session->write('msg','<p class="success">The photo gallery was susccessfully added!</p>');
		}
		else
			$this->Session->write('msg','<p class="error">An error occured. The photo gallery was not added!</p>');
		$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/admin'));
	}
	
	function admin_index($page = 1) 
	{
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->PhotoGallery->findCount(), $this->Pager->per_page, $page);
		$data = $this->PhotoGallery->findAll(null, 'header, published, authors, id, comments, publish_date', "published DESC,id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','photos');
		
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - PHOTO GALLERIES";
		$this->render('admin', 'admin');
	}
	
	function admin_add() 
	{	
		$this->Auth->checkPermissions();
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
		$this->_back('photo_galleries');
		
		$this->set('css', $css);
		$this->set('js', $js);
		$this->set('category','photos');
		$this->set('data', $this->Session->read('data'));	
			
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - PHOTO GALLERIES";
		$this->render('add', 'admin');
	}
	
	function admin_edit($id = null)
	{	
		$this->Auth->checkPermissions();
		if(($this->PhotoGallery->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/photo_galleries/');
			exit();
		}
		
		$this->PhotoGallery->setId($id);
		
		if (empty($this->data))
		{
			$js = '<script type="text/javascript" src="'.$this->webroot.'js/datepicker/datepicker.php"></script>';
			$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
			$this->_back('photo_galleries');
			
			$this->set('css', $css);
			$this->set('js', $js);
			$this->set('data', $this->PhotoGallery->read());
			$this->set('category','photos');
			
			$this->_sessionDel();
			
			$this->pageTitle = "Drumb - PHOTO GALLERIES";
			$this->render('edit', 'admin');
		}
		else
		{
			if ($this->PhotoGallery->save($this->data))
				$this->Session->write('msg','<p class="success">The photo gallery was susccessfully changed!</p>');
			else
				$this->Session->write('msg','<p class="error">An error occured. The photo gallery was not changed!</p>');
			
			$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/admin'));
		}
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if ($this->PhotoGallery->del($id)) 
		{
			$dir = WWW_ROOT . "upload" . DS . "photos" . DS . $id . DS;
			$this->Filemanager->deleteDir($dir);
			$this->PhotoGallery->delPhotos('photos', $id);
			$this->set('msg','The photo gallery was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The photo gallery was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_filter($filter = null, $page = 1) 
	{
		$this->Auth->checkPermissions();

		$paging =$this->Pager->getPagerData($this->PhotoGallery->findCount("header LIKE '%".$_GET['filter']."%'"), $this->Pager->per_page, $_GET['page']);
		$data = $this->PhotoGallery->findAll("header LIKE '%".$_GET['filter']."%'", 'header, published, date, club, city, authors, id, comments, publish_date', "published DESC, id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','photos');
		$this->set('filter', $_GET['filter']);
		
		$this->_sessionDel();

		$this->pageTitle = "Drumb - PHOTO GALLERIES";
		$this->render('admin', 'admin');
	}
		
	function index($page = null) 
	{
		if(isset($this->params['requested']) && $page == null)
		{
			$data = $this->PhotoGallery->findAll("published = 'Y' AND CURDATE() >= publish_date", 'id, header, club, date, city', 'id DESC', 3);
			for($count = 0; $count < count($data); $count++)
			{
				$photo = $this->Filemanager->searchDir(WWW_ROOT . 'upload' . DS . 'photos' . DS . $data[$count]['PhotoGallery']['id'] . DS,0,'FILES',0,0,1);
				$data[$count]['PhotoGallery']['photo'] = $photo[0]['File']['path'];
				$data[$count]['PhotoGallery']['coordinates'] = $this->Filemanager->squareImg($photo[0]['File']['path']);
			}
			return $data;
		}
		$this->Pager->per_page = 10;
		$paging =$this->Pager->getPagerData($this->PhotoGallery->findCount("published = 'Y' AND CURDATE() >= publish_date"), $this->Pager->per_page, $page);
		
		if($page > $paging->numPages) 
		{
			$this->redirect('/error404/');
			exit();	
		}
		
		$data = $this->PhotoGallery->findAll("published = 'Y' AND CURDATE() >= publish_date", 'header, date, club, city, authors, id, content,comments, popularity', "id DESC","".$paging->offset.", ".$paging->limit."");
		
		$data['page'] = $paging->page;
		$data['numPages'] = $paging->numPages;
			
		$this->set('data', $data);
		
		$this->pageTitle = "PHOTO GALLERIES, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('index', 'user');		
	}
	
	function get_by_tag($tag = null)
	{
		if($tag != null && isset($this->params['requested'])) 
			return $this->PhotoGallery->findAll("published = 'Y' AND CURDATE() >= publish_date AND tag LIKE '".$tag."'", 'header, date, club, city, authors, id, content,comments, popularity', "id DESC", 10);
	}
	
	function view($id = null, $name = null, $page = 1) 
	{
		if($id == null || $name == null || $this->PhotoGallery->findCount("published = 'Y' AND id = '".$id."' AND CURDATE() >= publish_date") == 0)
		{
			$this->redirect('/error404/');
			exit();
		}

		$this->PhotoGallery->updatePopularity($id, '+');
		
		$data = $this->requestAction('/photos/get_photos/'.$id.'/');
		$this->PhotoGallery->setId($id);
		$gallery = $this->PhotoGallery->read('header, id, tag');
		$data['PhotoGallery'] = $gallery['PhotoGallery']['header'];
		
		if(empty($data)) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$news = $this->requestAction('/news/get_by_tag/'.$gallery['PhotoGallery']['tag'].'/');
		$parties = $this->requestAction('/parties/get_by_tag/'.$gallery['PhotoGallery']['tag'].'/');
		$photo_galleries = $this->requestAction('/photo_galleries/get_by_tag/'.$gallery['PhotoGallery']['tag'].'/');
		$competitions = $this->requestAction('/competitions/get_by_tag/'.$gallery['PhotoGallery']['tag'].'/');
		$related = array();
		
		if(!empty($news))
		{
			foreach($news as $item) 
				$related[] = array('cat' => 'news', 'header' => $item['dnb_news']['header'], 'id' => $item['dnb_news']['id'], 'views' => $item['dnb_news']['popularity'], 'comments' => $item['dnb_news']['comments'], 'publish_date' => $item['dnb_news']['publish_date'], 'color' => $item['dnb_news_categories']['color'], 'category' => $item['dnb_news_categories']['name'], 'user' => $item['dnb_users']['username']);
		}
		if(!empty($photo_galleries))
		{
			foreach($photo_galleries as $item) 
			{
				if($item['PhotoGallery']['header'] == $gallery['PhotoGallery']['header'] && $gallery['PhotoGallery']['id'] == $item['PhotoGallery']['id'])
					continue;
				$photo = $this->Filemanager->searchDir(WWW_ROOT . 'upload' . DS . 'photos' . DS . $item['PhotoGallery']['id'] . DS,0,'FILES',0,0,1);
				$related[] = array('cat' => 'photos', 'path' => $photo[0]['File']['path'], 'cor' => $this->Filemanager->squareImg($photo[0]['File']['path']), 'header' => $item['PhotoGallery']['header'], 'id' => $item['PhotoGallery']['id'], 'views' => $item['PhotoGallery']['popularity'], 'comments' => $item['PhotoGallery']['comments'], 'date' => $item['PhotoGallery']['date'], 'city' => $item['PhotoGallery']['city'], 'club' => $item['PhotoGallery']['club'], 'user' => $item['PhotoGallery']['authors']);
			}
		}
		if(!empty($parties))
		{
			foreach($parties as $item) 
				$related[] = array('cat' => 'parties', 'header' => $item['Party']['name'], 'id' => $item['Party']['id'], 'views' => $item['Party']['popularity'], 'comments' => $item['Party']['comments'], 'date' => $item['Party']['date'], 'city' => $item['Party']['city'], 'club' => $item['Party']['club'], 'state' => $item['Party']['state']);
		}
		if(!empty($competitions))
		{
			foreach($competitions as $item) 
				$related[] = array('cat' => 'competitions', 'header' => $item['Competition']['header'], 'id' => $item['Competition']['id'], 'views' => $item['Competition']['popularity'], 'from_date' => $item['Competition']['from_date'], 'to_date' => $item['Competition']['to_date']);
		}
		$this->set('related', $related);
		$this->set('data', $data);
		$this->set('page', $page);
		
		$this->pageTitle = "PHOTO GALLERIES - ".$gallery['PhotoGallery']['header'].", dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('gallery', 'user');		
	}
	
	function get_gallery($id = null) 
	{
		if(isset($this->params['requested']) && $id != null)
			return array_pop($this->PhotoGallery->find("published = 'Y' AND id = '".$id."' AND CURDATE() >= publish_date", 'header, city, club, date, authors'));
	}
}
?>