<?php

/**
 * Controller :: Photos
 *
 * photos_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $30.01.2007$
 */

class PhotosController extends AppController
{
    var $name = 'Photos';
	
    function admin_index($page = 1, $gallery_id = null) 
    {
    	$this->Auth->checkPermissions();
    	$paging =$this->Pager->getPagerData($this->Photo->findCount("dnb_photo_gallery_id='".$gallery_id."'"), $this->Pager->per_page, $page);
		$data = $this->Photo->findAll("dnb_photo_gallery_id='".$gallery_id."'", "file_name, id, comments", "id ASC","".$paging->offset.", ".$paging->limit."");
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/lightbox/spica.php">';
		$js .= '</script><script type="text/javascript" src="'.$this->webroot.'js/lightbox/lightbox_plus.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/lightbox/lightbox.php" />';
		
		if(!$this->Session->check('parent'))
			@$this->Session->write('parent', strstr($_SERVER['HTTP_REFERER'], '/admin'));
		$this->_back('photo_galleries',$this->Session->read('parent'));
		
		$this->set('css', $css);
		$this->set('js', $js);
    	$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','photos');
		$this->set('gallery_id', $gallery_id);
		
		$this->_sessionDel();

		$this->pageTitle = "Drumb - PHOTOS";		
		$this->render('admin', 'admin');
	}
	
	function admin_add()
	{
		$this->Auth->checkPermissions();
		$dir = WWW_ROOT . "upload" . DS . "photos" . DS . $this->data['Photo']['gallery_id'] . DS;
		
		if ((strtolower(pathinfo($_FILES['photo']["name"], PATHINFO_EXTENSION))) == 'zip' )
			$origin =$this->Filemanager->unzip($dir, $_FILES['photo']["tmp_name"], 20000000);
		else
			$origin = $this->Filemanager->upload($_FILES['photo'], $dir, array('jpg', 'gif', 'jpeg'), 20000000);
		
		if($origin)
		{
			if(is_array($origin)) 
				$this->Photo->save($origin, $this->data['Photo']['gallery_id']);
			else
				$this->Photo->save(array('file_name' => basename($origin),'dnb_photo_gallery_id' => $this->data['Photo']['gallery_id']));
			$this->Session->write('msg','<p class="success">The file was susccessfully uploaded!</p>');
		}
		$this->redirect('/admin/photos/1/'.$this->data['Photo']['gallery_id'].'');
	}
	
	function admin_delete_file()
	{
		$this->Auth->checkPermissions();
		$dir = WWW_ROOT . "upload" . DS . "photos" . DS . $this->Photo->galleryId($_POST['id']) . DS . $_POST['name'];
		if ($this->Photo->del($_POST['id'])) 
		{
			$this->Filemanager->deleteFile($dir);
			$this->Photo->delComments('photos', $_POST['id']);
			$this->set('msg','The file was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The file was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function index($gallery_id = null, $page = 1) 
	{		
		if($gallery_id == null) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$photo = substr($gallery_id, strrpos($gallery_id, "-") + 1, strlen($gallery_id));
		$gallery_id = substr($gallery_id, 0, strrpos($gallery_id, "-"));
		$this->Pager->per_page = 1;
    	$paging =$this->Pager->getPagerData($this->Photo->findCount("dnb_photo_gallery_id='".$gallery_id."'"), $this->Pager->per_page, $photo);
		$data = array_pop($this->Photo->findAll("dnb_photo_gallery_id='".$gallery_id."'", "file_name, id, comments", "file_name ASC","".$paging->offset.", ".$paging->limit.""));
		
		if(empty($data)) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$this->Photo->updatePopularity($data['Photo']['id'], '+');
			
		if($photo > 1) 
			$data['previous'] = array_pop($this->Photo->findAll("dnb_photo_gallery_id='".$gallery_id."'", "file_name, id, comments", "file_name ASC","".($paging->offset - 1).", ".$paging->limit.""));
		else
			$data['previous'] = array();
		
		$data['next'] = array_pop($this->Photo->findAll("dnb_photo_gallery_id='".$gallery_id."'", "file_name, id, comments", "file_name ASC","".($paging->offset + 1).", ".$paging->limit.""));
		$data['page'] = $paging->page;
		$data['comments_page'] = $page;
		$data['numPages'] = $paging->numPages;
		$data['gallery'] = $this->requestAction('/photo_galleries/get_gallery/'.$gallery_id.'/');
	
		$this->set('data', $data);
		
		$this->pageTitle = "PHOTO GALLERIES - ".$data['gallery']['header'].", dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('gallery', 'gallery');		
	}
	
	function view($gallery_id = null, $photo_id = null, $header = null) 
	{
		if($gallery_id == null || $photo_id == null || $header == null) 
		{
			$this->redirect('/error404/');
			exit();
		}
		$photos = $this->Photo->findAll("dnb_photo_gallery_id = '".$gallery_id."'",'id', 'file_name ASC');
		if(empty($photos))
		{
			$this->redirect('/error404/');
			exit();
		}
		for($i = 0; $i < count($photos); $i++) 
		{
			if($photos[$i]['Photo']['id'] == $photo_id) 
			{
				$this->redirect('/photos/'.$gallery_id.'-'.++$i.'/'.$header.'/');
				exit();
			}
		}
		$this->redirect('/photo-galleries/'.$gallery_id.'/'.$header.'/');
	}
	
	function get_photos($gallery_id = null) 
	{
		if(isset($this->params['requested']) && $gallery_id != null)
			return $this->Photo->findAll("dnb_photo_gallery_id = '".$gallery_id."'", 'file_name, comments, popularity, id', "file_name ASC");
	}
}

?>