<?php

/**
 * Controller :: Posts
 *
 * posts_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $16.02.2007$
 */

class PostsController extends AppController
{
    var $name = 'Posts';
    
    function get_count($id = null) 
    {
    	if(isset($this->params['requested']))
			return $this->Post->findCount(PREFIX."topic_id = '".$id."'");
    }
    
    function admin_index($page = 1, $id = null) 
	{
		$this->Auth->checkPermissions();
		$paging = $this->Pager->getPagerData($this->Post->findCount(PREFIX."topic_id = '".$id."'"), $this->Pager->per_page, $page);
		$data = $this->Post->findAll(PREFIX."topic_id = '".$id."'", null, "id DESC","".$paging->offset.", ".$paging->limit."");
	
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('id', $id);
		$this->set('category','forum');
		
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - POSTS";
		$this->render('admin_index', 'admin');
	}
	
	function admin_filter() 
	{
		$this->Auth->checkPermissions();
		
		$paging = $this->Pager->getPagerData($this->Post->findCount(PREFIX."topic_id = '".$_GET['id']."' AND subject LIKE '%".$_GET['filter']."%'"), $this->Pager->per_page, $_GET['page']);
		$data = $this->Post->findAll(PREFIX."topic_id = '".$_GET['id']."' AND subject LIKE '%".$_GET['filter']."%'", null, "id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('id', $_GET['id']);
		$this->set('category','forum');
		$this->set('filter', $_GET['filter']);
		
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - POSTS";
		$this->render('admin_index', 'admin');
	}
	
	function admin_edit($id = null)
	{
		$this->Auth->checkPermissions();
		if(($this->Post->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/Posts/');
			exit();
		}
		
		$this->Post->setId($id);
		
		if (empty($this->data))
		{
			$js = '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
			$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';
			$this->_back('posts');
			$this->set('data', $this->Post->read());
			$this->set('category','forum');
			$this->set('css', $css);
			$this->set('js', $js);
			$this->_sessionDel();
			
			$this->pageTitle = "Drumb - POSTS, EDIT";
			$this->render('admin_edit', 'admin');
		}
		else
		{
			if ($this->Post->save($this->data))
				$this->Session->write('msg','<p class="success">The Post was susccessfully changed!</p>');
			else
				$this->Session->write('msg','<p class="error">An error occured. The Post was not changed!</p>');
			
			$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/admin').'#msg/');
		}
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if ($this->Post->del($id))
		{
			$this->set('msg','The Post was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The Post was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function index($page = 1, $id = null) 
	{
		if($id == null)
		{
			$this->redirect('/error404/');
			exit();
		}
		$count = $this->Post->findCount(PREFIX."topic_id = '".$id."'");
		$paging = $this->Pager->getPagerData($count, $this->Pager->per_page, $page);
		$data = $this->Post->table($id,$paging->offset,$paging->limit);
		
		$name = $this->requestAction('/topics/get_name/'.$id.'/');
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/tiny_mce/tiny_mce_gzip.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/datepicker/datepicker.php" />';

		$count = ($this->requestAction('/comments/get_count/'.$id.'/') / $this->Pager->per_page) + 1;
		$this->set('css', $css);
		$this->set('js', $js);
		$this->set('page', $paging->page);
		$this->set('last_page', $count);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('id', $id);
		$this->set('name', $name);
		
		$this->pageTitle = "Fórum - " . $name .  ', '. COURSE;
		$this->render('index', 'forum');
	}
	function get_name($id = null) 
	{
		if(isset($this->params['requested']))
		{
			$this->Post->setId($id);
			$name = $this->Post->read();
			return $name['Post'];
		}	
	}
	
	function add() 
	{	
		if(!empty($this->data))
		{
			if($this->Post->save($this->data)) 
				$this->Session->write('msg','<p class="success">Príspevok ból úspešne pridaný!</p>');
			else
				$this->Session->write('msg','<p class="error">Vyskitla sa chyba. Príspevok neból pridaný!</p>');
			$this->redirect('/prispevky/1/'.$this->data['Post'][PREFIX.'topic_id'].'/');
			exit();
		}
		
		$this->redirect('/error404/');
		exit();
	}
}

?>