<?php

/**
 * Controller :: TodoTasks
 *
 * todo_tasks_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $03.02.2007$
 */

class TodoTasksController extends AppController
{
    var $name = 'TodoTasks';
	
    function admin_add()
	{
		$this->Auth->checkPermissions();
		if($this->TodoTask->save($this->data))
			$this->Session->write('msg','<p class="success">The task was susccessfully added!</p>');
		else
			$this->Session->write('msg','<p class="error">An error occured. The task was not added!</p>');
		
		$this->redirect('/admin/todo_list/');
	}
	
	function admin_index($page = 1) 
	{
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->TodoTask->findCount(), $this->Pager->per_page, $page);
		$data = $this->TodoTask->table();
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('statistics', $this->TodoTask->getStatistics());
		$this->set('category','');
		
		$this->_sessionDel();
		
		$this->pageTitle = "Drumb - TODO LIST";
		$this->render('admin', 'admin');
	}
	
	function admin_edit($id = null)
	{
		$this->Auth->checkPermissions();
		if(($this->TodoTask->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/todo_list/');
			exit();
		}
		
		$this->TodoTask->setId($id);
		
		if (empty($this->data))
		{
			$this->_back('todo_list');
			$this->set('data', $this->TodoTask->read());
			$this->set('category','');
			
			$this->_sessionDel();
			
			$this->pageTitle = "Drumb - TODO LIST";
			$this->render('edit', 'admin');
		}
		else
		{
			if ($this->TodoTask->save($this->data))
				$this->Session->write('msg','<p class="success">The task was susccessfully changed!</p>');
			else
				$this->Session->write('msg','<p class="error">An error occured. The task was not changed!</p>');
			
			$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/admin').'#msg/');
		}
	}
	
	function admin_not_done($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->TodoTask->setId($id);
		
		if ($this->TodoTask->saveField('done', 'N')) 
		{
			$this->set('msg','Status was susccessfully changed!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. Status was not changed!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_done($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->TodoTask->setId($id);
		
		if ($this->TodoTask->saveField('done', 'Y')) 
		{
			$this->set('msg','Status was susccessfully changed!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. Status was not changed!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if ($this->TodoTask->del($id))
		{
			$this->set('msg','The task was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The task was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
}

?>