<?php

/**
 * Controller :: Topics
 *
 * topics_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $16.02.2007$
 */

class TopicsController extends AppController
{
    var $name = 'Topics';
    
	function admin_add()
	{
		$this->Auth->checkPermissions();
		if($this->Topic->save($this->data))
			$this->Session->write('msg','<p class="success">The topic was susccessfully added!</p>');
		else
			$this->Session->write('msg','<p class="error">An error occured. The topic was not added!</p>');
		
		$this->redirect('/admin/topics/');
	}
	
	function admin_index($page = 1) 
	{
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->Topic->findCount(), $this->Pager->per_page, $page);
		$data = $this->Topic->findAll(null, null, "id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('category','forum');
		
		$this->_sessionDel();
		
		$this->pageTitle = "Drumb - TOPICS";
		$this->render('admin_index', 'admin');
	}
	
	function admin_edit($id = null)
	{
		$this->Auth->checkPermissions();
		if(($this->Topic->findCount("id=".$id."")) == 0) 
		{
			$this->redirect('/admin/topics/');
			exit();
		}
		
		$this->Topic->setId($id);
		
		if (empty($this->data))
		{
			$this->_back('topics');
			$this->set('data', $this->Topic->read());
			$this->set('category','forum');
			
			$this->_sessionDel();
			
			$this->pageTitle = "Drumb - TOPIC, EDIT";
			$this->render('admin_edit', 'admin');
		}
		else
		{
			if ($this->Topic->save($this->data))
				$this->Session->write('msg','<p class="success">The topic was susccessfully changed!</p>');
			else
				$this->Session->write('msg','<p class="error">An error occured. The topic was not changed!</p>');
			
			$this->redirect(strstr($_SERVER['HTTP_REFERER'], '/admin').'#msg/');
		}
	}
	
	function admin_unpublish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Topic->setId($id);
		
		if ($this->Topic->saveField('published', 'N')) 
		{
			$this->set('msg','The topic was was susccessfully unpublished!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The topic was not unpublished!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_publish($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->Topic->setId($id);
		
		if ($this->Topic->saveField('published', 'Y')) 
		{
			$this->set('msg','The topic was susccessfully published!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The topic was not published!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if ($this->Topic->del($id))
		{
			$this->set('msg','The topic was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The topic was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function index($page = 1) 
	{
		$paging = $this->Pager->getPagerData($this->Topic->findCount("published = 'Y'"), $this->Pager->per_page, $page);
		$data = $this->Topic->findAll("published = 'Y'", null, "id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		
		$this->pageTitle = "Fórum, " . COURSE;
		$this->render('index', 'forum');
	}
	
	function get_name($id = null) 
	{
		if(isset($this->params['requested']))
		{
			$this->Topic->setId($id);
			$name = $this->Topic->read('name');
			return $name['Topic']['name'];
		}	
	}
}

?>