<?php
/**
 * Controller :: Users
 *
 * users_controller.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $11.02.2007$
 */

class UsersController extends AppController
{
    var $name = 'Users';
	var $components = array('Mailer');
	var $banned_ips = array('196.207.198.219', '41.208.177.210');
	var $banned_mails = array('peace_ojima@yahoo.com', 'blessing_ojima@yahoo.com', '_ojima', 'ojima@', 'mary_mabou');
	
	
	function admin_index($page = 1) 
	{
		$this->Auth->checkPermissions();
		$paging =$this->Pager->getPagerData($this->User->findCount("username <> '".$this->Auth->getUserName()."' AND dnb_group_id <> '1'"), $this->Pager->per_page, $page);
		$data = $this->User->findAll("username <> '".$this->Auth->getUserName()."' AND dnb_group_id <> '".ADMIN."'", "id, username, state, last_visit, email, dnb_group_id, ip, online", "id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('groups', $this->requestAction('/admin/groups/get_groups/'));
		$this->set('category','users');
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - USERS";		
		$this->render('admin', 'admin');
	}
	
	function admin_filter() 
	{
		$this->Auth->checkPermissions();
		
		$paging =$this->Pager->getPagerData($this->User->findCount("WHERE username <> '".$this->Auth->getUserName()."' AND dnb_group_id <> '".ADMIN."' AND username LIKE '%".$_GET['filter']."%'"), $this->Pager->per_page, $_GET['page']);
		$data = $this->User->findAll("WHERE username <> '".$this->Auth->getUserName()."' AND dnb_group_id <> '".ADMIN."' AND username LIKE '%".$_GET['filter']."%'", null, "id DESC","".$paging->offset.", ".$paging->limit."");
		
		$this->set('groups', $this->requestAction('/admin/groups/get_groups/'));
		$this->set('category','users');
		$this->set('page', $paging->page);
		$this->set('numPages', $paging->numPages);
		$this->set('data', $data);
		$this->set('filter', $_GET['filter']);
		
		$this->_sessionDel(true);
		
		$this->pageTitle = "Drumb - USERS";
		$this->render('admin', 'admin');
	}
	
	function admin_ban($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->User->setId($id);
		
		if ($this->User->saveField('state', 'banned')) 
		{
			$this->set('msg','The user was susccessfully banned!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The user was not banned!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_delete($id = null)
	{	
		$this->Auth->checkPermissions();
		if ($this->User->del($id)) 
		{
			$dir = WWW_ROOT . "upload" . DS . "users" . DS . $id . DS;
			$this->Filemanager->deleteDir($dir);
			$this->User->deleteHistory($id);	
			$this->set('msg','The user was susccessfully deleted!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The artist was not deleted!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_authorize($id = null)
	{	
		$this->Auth->checkPermissions();
		$this->User->setId($id);
		
		if ($this->User->saveField('state', 'authorized')) 
		{
			$this->set('msg','The user was susccessfully authorized!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The user was not authorized!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_set_group()
	{	
		$this->Auth->checkPermissions();
		$this->User->setId($_POST['id']);
		
		if ($this->User->saveField('dnb_group_id', $_POST['group_id'])) 
		{
			$this->set('msg','The group was susccessfully changed!');
			$this->set('flag','success');
		}
		else 
		{
			$this->set('msg','An error occured. The group was not changed!');
			$this->set('flag','error');
		}
		$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
	}
	
	function admin_login() 
	{
		$result = $this->Auth->login($_POST['login'], $_POST['password']);
		
		if (!$result) 
		{
			$this->set('msg','Bad login or password!');
			$this->set('flag','error');
			$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			exit();
		}
		
		if ($result == 'banned') 
		{
			$this->set('msg','Your account was banned!');
			$this->set('flag','error');
			$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			exit();
		}
		
		if ($result == 'inactive') 
		{
			$this->set('msg','Your account is not active!');
			$this->set('flag','error');
			$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			exit();
		}
		
		exit();
	}
	
	function login() 
	{
		if(empty($_POST)) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		if(strlen($_POST['password']) != 40)
			$_POST['password'] = sha1($_POST['password']);
		
		$result = $this->Auth->login($_POST['login'], $_POST['password']);
		
		if (!$result) 
		{
			if(isset($_POST['ajax'])) 
			{
				$this->set('msg','Bad login or password!');
				$this->set('flag','error');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			else
				$this->Session->write('msg','<p class="error">Bad login or password!</p>');
		}
		
		if ($result == 'banned') 
		{
			if(isset( $_POST['ajax'])) 
			{
				$this->set('msg','Your account was banned!');
				$this->set('flag','error');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			else
				$this->Session->write('msg','<p class="error">Your account was banned!</p>');
		}
		
		if ($result == 'inactive') 
		{
			if(isset( $_POST['ajax'])) 
			{
				$this->set('msg','Your account is not active!');
				$this->set('flag','error');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			else
				$this->Session->write('msg','<p class="error">Your account is not active!</p>');
		}
		
		if(isset($_POST['ajax']))
			print 'success';
		else	
			$this->redirect($_SERVER['HTTP_REFERER']);
		exit();
	}
	
	function logout() 
	{
		$this->Auth->logout();
		$this->Session->write('msg','<p class="tick">You have been loged out, have a nice day!</p>');
		$this->redirect('/news/');
	}
	
	function filter()
	{
		$condition = '';

		if(@$_GET['nick'] != '')
			$condition .= "username LIKE '%".$_GET['nick']."%' ";
		
		if(@$_GET['location'] != '') 
		{
			if($condition == '')
				$condition .= "location LIKE '%".$_GET['location']."%' ";
			else
				$condition .= "AND location LIKE '%".$_GET['location']."%' ";
		}
		
		if(@$_GET['sex'] != '')
		{
			if($condition == '')
				$condition .= "sex LIKE '".$_GET['sex']."' ";
			else
				$condition .= "AND sex LIKE '".$_GET['sex']."' ";
		}
		
		$month = date('m');
  	  	$day = date('d');
    	$year = date('Y');
    	$hour = date('H');
    	$min = date('i');
    	$sec = date('s');
    	$now = date("Y-m-d H:i:s");
    	$sub = date("Y-m-d H:i:s", mktime($hour, $min - ONLINE, $sec, $month, $day, $year));
    	
		if(@$_GET['online'] == 'online')
		{
			if($condition == '')
				$condition .= "online <= '".$now."' AND online >= '".$sub."' ";
			else
				$condition .= "AND online <= '".$now."' AND online >= '".$sub."' ";
		}
		
		if($condition == '')
			$condition .= "state = 'authorized'";
		else
			$condition .= "AND state = 'authorized'";
		$condition .= "AND id <> '".FATHER."'";	
		$this->Pager->per_page = 24;

		$paging = $this->Pager->getPagerData($this->User->findCount($condition), $this->Pager->per_page, @$_GET['page']);
		if(@$_GET['page'] == 1 || !isset($_GET['page']))
			$paging->limit = $paging->limit - 1;
		$data = $this->User->findAll($condition, 'id, username, sex', "created DESC" ,"".$paging->offset.", ".$paging->limit."");
		
		if(@$_GET['page'] == 1 || !isset($_GET['page']))
			$data = array_merge($this->User->findAll("id = '".FATHER."'", 'id, username, sex'), $data);
		
		$data['page'] = $paging->page;
		$data['numPages'] = $paging->numPages;

		$this->set('data', $data);
			
		$this->pageTitle = "USERS, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('index', 'user');		
	}
	
	function index($user = null, $page = 1) 
	{		
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/lightbox/spica.php">';
		$js .= '</script><script type="text/javascript" src="'.$this->webroot.'js/lightbox/lightbox_plus.php"></script>';
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/lightbox/lightbox.php" />';
		
		$data = $this->User->find("username = '".strtolower($user)."'",'id, online, last_visit, created, description, location, comments, popularity, age, sex, username, last_visit, created, name');
		$this->User->updatePopularity($data['User']['id'], '+');
		
		if(empty($data)) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$data['User']['photos'] = $this->Filemanager->searchDir(WWW_ROOT . "upload" . DS . "users" . DS . $data['User']['id'] . DS,0,'FILES');
		
		if(is_file(WWW_ROOT . "upload" . DS . "users" . DS . $data['User']['id'] . DS . 'photo_temp.jpg'))
			$this->Filemanager->deleteFile(WWW_ROOT . "upload" . DS . "users" . DS . $data['User']['id'] . DS . 'photo_temp.jpg');
		if(is_file(WWW_ROOT . "upload" . DS . "users" . DS . $data['User']['id'] . DS . 'photo_temp.gif'))
			$this->Filemanager->deleteFile(WWW_ROOT . "upload" . DS . "users" . DS . $data['User']['id'] . DS . 'photo_temp.gif');
		
		if(($artist = $this->requestAction('/artists/get_artist/'.$data['User']['id'].'/Y/'))) {
			$data['User']['artist'] = $artist['Artist']['id'];
			$data['User']['url'] = $artist['Artist']['url'];
		}
		
		if(($artist = $this->requestAction('/artists/get_artist/'.$data['User']['id'].'/'))) {
			$data['User']['artistsettings'] = $artist['Artist']['id'];
			$data['User']['url'] = $artist['Artist']['url'];
		}

		$this->set('data', $data);
		$this->set('css', $css);
		$this->set('js', $js);
		$this->set('page', $page);
		
		$this->pageTitle = "PROFILE - ".$user.", dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('profile', 'user');		
	}
	
	function settings($page = 1) 
	{
		if(!$this->Auth->validate()) 
		{
			$this->redirect('/error404/');
			exit();
		}

		$this->User->setId($this->Auth->getUserId());
		
	    $data = $this->User->read("sex, description, age, name, location, id, username, notification");
	
	    $dir = WWW_ROOT . "upload" . DS . "users" . DS . $data['User']['id'] . DS;
		if(is_file($dir . 'photo_temp.jpg'))
			$this->Filemanager->deleteFile($dir . 'photo_temp.jpg');
		if(is_file($dir . 'photo_temp.gif'))
			$this->Filemanager->deleteFile($dir . 'photo_temp.gif');
			
		$data['User']['description'] = $this->_html2bb($data['User']['description']);
		
		$data['User']['photos'] = $this->Filemanager->searchDir($dir,0,'FILES');
		$data['User']['parties'] = $this->requestAction('/visitors/all_parties/'.$this->Auth->getUserId().'/');
		
		if(empty($data)) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		if($this->requestAction('/artists/is_artist/'.$this->Auth->getUserId().'/')) 
			$data['User']['artist'] = true;
		
		$this->set('data', $data);
		$this->set('page', $page);
		$this->pageTitle = "PROFILE SETTINGS, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('settings', 'user');		
	}
	
	function save_settings() 
	{
		if(empty($_POST)) 
		{
			$this->redirect('/users/settings/');
			exit();
		}
		
		if(!$this->Auth->validate()) 
		{
			$this->redirect('/error404/');
			exit();
		}
			
		$this->data['User']['age'] = $_POST['age'];
		$this->data['User']['name'] = strip_tags($_POST['name']);
		$this->data['User']['description'] =  $this->_processtext($this->_bb2html(strip_tags($_POST['about'])), 56);
		$this->data['User']['sex'] = $_POST['sex'];
		$this->data['User']['notification'] = $_POST['notification'];
		$this->data['User']['location'] = strip_tags($_POST['location']);

		if(!$this->User->validates($this->data)) 
		{
			if(isset($_POST['ajax'])) 
			{
				$this->set('msg','Age must be a number!');
				$this->set('flag','error_big message_margin');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			 else 
			{
				$this->Session->write('msg_form','<p class="error_big message_margin">Age must be a number!</p>');
				$this->redirect('/users/settings/');
				exit();
			}
		}
		
		if($_POST['new_password_retyped'] != '' || $_POST['new_password'] != '') 
		{
			if($_POST['new_password_retyped'] == $_POST['new_password']) 
			{
				if(strlen($_POST['new_password']) != 40)
					$this->data['User']['passwd'] = sha1($_POST['new_password']);
				else
					$this->data['User']['passwd'] = $_POST['new_password'];
			}
			else
			{
				if(isset($_POST['ajax'])) 
				{
					$this->set('msg','Passwords does not match!');
					$this->set('flag','error_big message_margin');
					$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
					exit();
				}
				else
				{
					$this->Session->write('msg_form','<p class="error_big message_margin">Passwords does not match!</p>');
					$this->redirect('/users/settings/');
					exit();
				}
			}
		}
		
		$this->User->setId($this->Auth->getUserId());
		$dir = WWW_ROOT . "upload" . DS . "users" . DS . $this->Auth->getUserId() . DS;
		if($this->User->save($this->data))
		{
			$this->Auth->setSex($this->data['User']['sex']);
			$this->Auth->setUserFullName($this->data['User']['name']);
			if(isset($_POST['ajax'])) 
			{
				$this->set('msg','Your settings was susccessfully saved!');
				$this->set('flag','tick_big message_margin');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			else
				$this->Session->write('msg_form','<p class="tick_big message_margin">Your settings was susccessfully saved!</p>');
		}
		else 
		{
			if(isset($_POST['ajax'])) 
			{
				$this->set('msg','An error occured. Your settings was not saved!');
				$this->set('flag','error_big message_margin');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
			} 
			else
				$this->Session->write('msg_form','<p class="error_big message_margin">An error occured. Your settings was not saved!</p>');
		}
		
		if(!empty($_FILES['photo']['name']))
		{
			$max = 4;
			$photos = 0;
			$count = $this->Filemanager->searchDir($dir,0,'FILES');
				
			foreach ($count as $file) 
			{
				if(!strstr($file['File']['name'], strtolower($this->Auth->getUserName())))
					$photos++;
			}
			
			if($photos >= $max)
			{
				$this->Session->write('msg','<p class="error">The photo was not uploaded! Maximal 4 photos allowed!</p>');
				$this->redirect('/users/settings/');
				exit();
			}
				
			if(($dest = $this->Filemanager->upload($_FILES['photo'], $dir, array('jpg', 'gif', 'jpeg'), 1000000))) 
			{				
				$this->Session->write('msg','<p class="tick">The file was susccessfully uploaded!</p>');
				$image = getimagesize($dest);
				if($image[0] > 800)
				{
					$ratio = ($image[0] / $image[1]);
					$image[0] = 800;
					$image[1] =	(800 / $ratio);
					$this->Filemanager->imgResize($dest,$dest,$image[0],$image[1]);
				}
			} 	
		}
		if(!empty($_FILES['file']['name']))
		{
			$this->Filemanager->createDir($dir);
			if(($dest = $this->Filemanager->upload($_FILES['file'], $dir, array('jpg', 'gif', 'jpeg'), 1000000, 'photo_temp.'.strtolower(pathinfo($_FILES['file']['name'], PATHINFO_EXTENSION))))) 
			{				
				$type = pathinfo($dest, PATHINFO_EXTENSION);
				if($type == 'jpg' || $type == 'jpeg' || $type == 'gif')
				{
					$image = getimagesize($dest);
					if($image[1] < 200) 
					{
						$this->Filemanager->imgResize($dest,$dest,((200 * $image[0]) / $image[1]), 200);						
						$image = getimagesize($dest);
					}
					else
						$image = getimagesize($dest);
					if($image[0] < 200)
						$this->Filemanager->imgResize($dest,$dest,200, (200 / ($image[0] / $image[1])));
				}
				$this->Session->write('dest', $dest);
				$this->Session->write('dir', $dir);
				$this->redirect('/users/photo/');
			} 
			else 
				$this->redirect('/users/settings/');
			exit();
		}	
		$this->redirect('/users/settings/');
	}
	
	function photo($action = null) 
	{
		if(!$this->Session->read('dest') || !$this->Session->read('dir') || !$this->Auth->validate()) 
		{
			$this->redirect('/error404/');
			exit();
		}

		$dest = $this->webroot.strstr($this->Filemanager->htmlPath($this->Session->read('dest')),'upload');
		$full_dest = $this->Session->read('dest');
		
		if($action == 'crop')
		{
			if($this->Filemanager->imgCrop($full_dest,$full_dest,$_GET['x'], $_GET['y'], $_GET['width'], $_GET['height'])) 
			{
				if($this->Filemanager->imgResize($full_dest,$this->Session->read('dir').strtolower($this->Auth->getUserName()).'_1.jpg',200,200)) 
				{
					$this->Filemanager->imgResize($full_dest,$this->Session->read('dir').strtolower($this->Auth->getUserName()).'_2.jpg',100,100);
					$this->Filemanager->imgResize($full_dest,$this->Session->read('dir').strtolower($this->Auth->getUserName()).'_3.jpg',60,60);
					$this->Filemanager->imgResize($full_dest,$this->Session->read('dir').strtolower($this->Auth->getUserName()).'_4.jpg',40,40);
					
					$this->Filemanager->deleteFile($full_dest);
					
					$this->Session->write('msg','<p class="tick">Photo was susccessfully croped!</p>');
					$this->Session->write('msg_form','<p class="tick_big message_margin">Your settings was susccessfully saved!</p>');

					$this->Session->del('dest');
					$this->Session->del('dir');
				}
			} 
			else
				$this->Session->write('msg','<p class="error">A error occured. The photo was not croped!</p>');
			
			$this->redirect('/users/settings/');
			exit();
		}
		
		$css = '<link rel="stylesheet" type="text/css" href="'.$this->webroot.'css/interface/croper_usr.php" />';
		$js = '<script type="text/javascript" src="'.$this->webroot.'js/interface/interface.php"></script>';
		$image = getimagesize($this->Session->read('dest'));

		if($image[0] > 498) 
		{ 
			$ratio = ($image[0] / $image[1]);
			$image[0] = 498;
			$image[1] =	(498 / $ratio);
			$this->Filemanager->imgResize($full_dest,$full_dest,$image[0],$image[1]);
		}
		
		$data['width'] = $image[0];
		$data['height'] = $image[1];
		$data['dest'] = $dest;
			
		$this->set('data', $data);
		$this->set('dest', $dest);
		$this->set('css', $css);
		$this->set('js', $js);
		
		$this->pageTitle = "PROFILE SETTINGS, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('crop', 'user');
	}
	function get_name($id = null) 
	{
		if(isset($this->params['requested']))
		{
			$this->User->setId($id);
			$name = $this->User->read();
			return $name['User'];
		}	
	}
	function delete_photo($id = null,  $name = null, $ajax = null)
	{
		if($id == null || $name == null || !$this->Auth->validate()) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$data = $this->User->find("id = '".$this->Auth->getUserId()."'", "id");
		
		if($id != $data['User']['id']) 
		{
			$this->redirect('/error404/');
			exit();
		}
		
		if($this->Filemanager->deleteFile(WWW_ROOT.'upload'. DS .'users'. DS . $id . DS . $name))
		{
			if($ajax)
			{
				$this->set('msg','The photo was susccessfully deleted!');
				$this->set('flag','tick_big message_margin message_margin');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			else
				$this->Session->write('msg_form','<p class="tick_big message_margin">The photo was susccessfully deleted!</p>');
		}
		else 
		{
			if($ajax)
			{
				$this->set('msg','A error occured. The photo was not deleted!');
				$this->set('flag','error message_margin message_margin');
				$this->render(null, 'clean', WWW_ROOT. DS . 'php' . DS . 'views' . DS . 'msg.php');
				exit();
			}
			else
				$this->Session->write('msg','<p class="error message_margin">A error occured. The photo was not deleted!</p>');
		}
		$this->redirect('/users/settings/');
	}
	
	function registration() 
	{	
		if($this->Auth->validate()) 
		{
			$this->redirect('/news/');
			exit();
		}
		
		if(!empty($_POST))
		{
			$this->Session->write('username', $_POST['username']);
			$this->Session->write('email', $_POST['email']);
			$this->Session->write('sex', $_POST['sex']);
			$this->Session->write('passwd', $_POST['passwd']);
			$this->Session->write('password_retyped', $_POST['password_retyped']);
			$ips = split(",",$this->_getIp());
			foreach($ips as $ip) 
			{
				if(in_array(trim($ip), $this->banned_ips)) 
				{
					$this->Session->write('msg_form','<p class="error_big message_margin">Your ip address was banned!</p>');
					$this->redirect('/users/registration/');
				exit();
				}
			}
			foreach($this->banned_mails as $mail) 
			{
				if($mail == $_POST['email'] || strstr($_POST['email'], $mail)) 
				{
					$this->Session->write('msg_form','<p class="error_big message_margin">Your email  address was banned!</p>');
					$this->redirect('/users/registration/');
				exit();
				}
			}	

			if(empty($_POST['passwd']) || empty($_POST['password_retyped']) || empty($_POST['sex']) || empty($_POST['email']) || empty($_POST['username']))
			{
				$this->Session->write('msg_form','<p class="warning_big message_margin">You left some empty fields, fill it first!</p>');
				$this->redirect('/users/registration/');
				exit();
			}
			
			if($_POST['answer'] != $this->Session->read('captcha'))
			{
				$this->Session->write('msg_form','<p class="error_big message_margin">You entered invalid number!</p>');
				$this->redirect('/users/registration/');
				exit();
			}
			
			if(!preg_match('/^[A-Za-z0-9_-]+$/', $_POST['username'])) 
			{
				$this->Session->write('msg_form','<p class="error_big message_margin_info">You entered invalid login! Only A-Z, 0-9, \'_-\' chars allowed!</p>');
				$this->redirect('/users/registration/');
				exit();
			}
			
			if(strlen($_POST['username']) < 3 || strlen($_POST['username']) > 15) 
			{
				$this->Session->write('msg_form','<p class="error_big message_margin_info">You entered invalid login! Login length must be betwean 3 and 15!</p>');
				$this->redirect('/users/registration/');
				exit();
			}
			
			if($this->User->findCount("username = '".$_POST['username']."'") > 0) 
			{
				$this->Session->write('msg_form','<p class="error_big message_margin_info">Sorry, this login is allready in use. Try something else!</p>');
				$this->redirect('/users/registration/');
				exit();
			}
			
			if(!preg_match(VALID_EMAIL, $_POST['email'])) 
			{
				$this->Session->write('msg_form','<p class="error_big message_margin">You entered invalid e-mail address!</p>');
				$this->redirect('/users/registration/');
				exit();
			}
			
			if($this->User->findCount("email = '".$_POST['email']."'") > 0) 
			{
				$this->Session->write('msg_form','<p class="error_big message_margin_info">Sorry, this e-mail address is allready in use. Are you sure you entered a right e-mail address?</p>');
				$this->redirect('/users/registration/');
				exit();
			}
			
			if($_POST['passwd'] != $_POST['password_retyped']) 
			{
				$this->Session->write('msg_form','<p class="error_big message_margin">Passwords does not match!</p>');
				$this->Session->del('passwd');
				$this->Session->del('password_retyped');
				$this->redirect('/users/registration/');
				exit();
			}
			
			$this->User->save(array('username' => $_POST['username'], 'sex' => $_POST['sex'], 'email' => $_POST['email'], 'passwd' => sha1($_POST['passwd'])));
			
			$this->Mailer->Subject = 'dnb.sk, registracia';
   			$this->Mailer->Message = 'Užívateľ '.$_POST['username'].' bol úspešne zaregistrovaný na portáli <a href="http://www.dnb.sk">www.dnb.sk</a>. Pre aktiváciu konta kliknite <a href="http://'.SERVER_NAME.'/users/activation/'.$_POST['username'].'/" >sem</a>. Ak sa Vám tento mail zle zobrazil alebo linka nieje klikateľná skopírujte uvedenú linku do prehliadača. http://'.SERVER_NAME.'/users/activation/'.$_POST['username'].'/.<br/>--<br/><a href="http://www.dnb.sk">www.dnb.sk</a>';
			$this->Mailer->AddAddress($_POST['username'], trim(strtolower($_POST['email'])));
			$this->Mailer->socketmail();
				
			$this->Session->del('captcha');
			$this->Session->write('msg_form','<p class="tick_big message_margin_info">An activation e-mail was sent to your email address, please follow the instruction to finish your registration! If you do not active your account within 2 days, the account will be deleted!</p>');
			
			$this->redirect('/users/registration/');
			exit();
		}
		
		$this->pageTitle = "USER REGISTRATION, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('registration', 'user');		
	}
	
	function forgot_password()
	{
		if($this->Auth->validate())
		{
			$this->redirect('/news/');
			exit();
		}
		
		if(!empty($_POST))
		{
			$this->Session->write('username', $_POST['username']);
			$this->Session->write('email', $_POST['email']);
			
			if($_POST['answer'] != $this->Session->read('captcha'))
			{
				$this->Session->write('msg_form','<p class="error_big message_margin">You entered invalid number!</p>');
				$this->redirect('/users/forgot-password/');
				exit();
			}
			
			if($this->User->findCount("email = '".$_POST['email']."' AND username = '".$_POST['username']."'") > 0 ) 
			{	
				$password = substr(strtolower(sha1(date('Y-m-d H:i:s'))), 0, 8);
				$this->User->savePasswd($_POST['username'],$_POST['email'],sha1($password));
				
				$this->Mailer->Subject = 'dnb.sk, nove heslo';
   			 	$this->Mailer->Message = $_POST['username'].'<br />'.'Vaše nové heslo je '.$password.'. Po prihlásení so ho možete zmeniť.<br/>--<br/><a href="http://www.dnb.sk">www.dnb.sk</a>';
				$this->Mailer->AddAddress($_POST['username'],trim(strtolower($_POST['email'])));
				$this->Mailer->socketmail();
				$this->Session->del('captcha');
				
				$this->Session->write('msg_form','<p class="tick_big message_margin_info">Your new password was susccessfully sent to your e-mail adress!</p>');
				$this->redirect('/users/forgot-password/');
				exit();
			}
			else 
			{
				$this->Session->write('msg_form','<p class="error_big message_margin">You entered invalid login or e-mail address!</p>');
				$this->redirect('/users/forgot-password/');
				exit();
			}	
		}
		
		$this->pageTitle = "FORGOT PASSWORD, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('forgot_password', 'user');		
	}
	
	function online_users()
	{
		if(isset($this->params['requested'])) 
		{
			$month = date('m');
	  	  	$day = date('d');
	    	$year = date('Y');
	    	$hour = date('H');
	    	$min = date('i');
	    	$sec = date('s');
	    	$now = date("Y-m-d H:i:s");
	    	$sub = date("Y-m-d H:i:s", mktime($hour, $min - ONLINE, $sec, $month, $day, $year));
	    	$count = $this->User->findCount("online <= '".$now."' AND online >= '".$sub."'");
	    	return $count;
		}
	}
	
	function activation($user = null)
	{
		if($this->Auth->validate()) 
		{
			$this->redirect('/news/');
			exit();
		}
		if($user == null || $this->User->findCount("username = '".$user."'") == 0)
		{
			$this->redirect('/error404/');
			exit();
		}
		
		$data = $this->User->find("username = '".$user."'", "state, id");
		if($data['User']['state'] != 'inactive')
			$this->set('msg_form','<p class="warning_big message_margin">Your account is allready actived!</p>');
		else
		{
			$this->User->setId($data['User']['id']);
			if($this->User->saveField('state', 'authorized')) 
			{
				
				$this->User->saveField('last_visit', date('Y-m-d H:i:s'));
				$subject = 'Vítam ťa na stránke www.dnb.sk!';
				$message = '<strong>Vítam ťa na stránke www.dnb.sk!</strong><br /><br />Registrácia bola úspešná, teraz môžeš bez obmedzenia využívať všetky funkcie nového dnb.sk, pridávať komentáre k článkom, fotkám, prispievať do msg boardov, či komunikovať s ďalšími zaregistovanými užívateľmi prostredníctvom pošty. Registrovaní užívateľia majú možnosť prehliadať a sťahovať mp3 či videá zo sekcie <strong>Media</strong> alebo využívať <strong>Bazar</strong>. V nastaveniach svojho profilu môžeš napísať niečo o sebe, meniť heslo alebo fotku.<br/><br/>Ak si dj, producent, či promotér, v sekcii <strong>Artist zone</strong> si môžeš prostredníctvom funkcie “<strong>Get account</strong>” vytvoriť a spravovať vlastný <strong>Artist</strong> profil, ktorého súčasťou môže byť info o tebe, fotky, odkaz na tvoj web, linky na vlastnú produkciu, alebo mixované sety. Umiestnenie v Artist zone musí schváliť niektorý z administrátorov webu. <br /><br />V prípade akýchkoľvek otázok, pripomienok alebo podnetov ti poradí <strong>OTEC</strong> prostredníctvom internej pošty po prihlásení na www.dnb.sk, alebo môžeš kontaktovať redakciu a administrátorov na e-maile info@dnb.sk. Na všetky správy sa budeme snažiť odpovedať v čo najkratšom čase.<br /><br /><strong>Podmienky a pravidlá pre registrovaných užívateľov:</strong><br /><br />Prosíme užívateľov, aby sa vo vzájomnej komunikácii, pošte a príspevkoch na verejných message boardoch vyhli vulgarizmom a osočovaniu ďalších užívateľov, spamovaniu, príspevkom s tématikou postihnutých, sexuálnej orientácie, náboženstva, alebo rasovej diskriminácie a pod.<br /><br />Aj keď sa administrátori pokúsia odstrániť alebo upraviť akýkoľvek všeobecne nežiadúci obsah tak rýchlo, ako je to len možné, je nemožné kontrolovať každý príspevok. Všetky príspevky vo fórach vyjadrujú pohľady a názory autora príspevku a nie administrátorov webmastera (okrem príspevkov od týchto ľudí) a preto za ne nenesú žiadnu zodpovednosť.<br /><br />Webmaster a administrátor majú právo odstrániť, upraviť, presunúť alebo ukončiť akúkoľvek tému, kedykoľvek zistia, že odporuje podmienkam uvedeným vyššie. <strong>Užívateľovi, ktorý opakovane poruší tieto jednoduché pravidlá aj po napomenutí môže byť dočasne zablokované, alebo úplne zrušené konto.</strong><br /><br />Ak chceš byť po účasti v súťažiach na dnb.sk zaradený(á) do žrebovania, nastav v kolonke Name svoje skutočné meno. Výhercov súťaží o voľné vstupy a iné ceny je niekedy potrebné overiť podľa dokladu totožnosti, teda podľa mena a priezviska. Tento údaj bude prístupný len administrátorovi webu pri žrebovaní.';
				$this->User->addFreind(FATHER, $data['User']['id']);
				$this->User->sendMsg($data['User']['id'],$subject,$message,FATHER);
				$this->set('msg_form','<p class="tick_big message_margin_info">Your account was susccessfully actived! Thanks for registration, welcome to dnb.sk!</p>');
			}	
			else
				$this->set('msg_form','<p class="error_big message_margin_info">An error occured. Your account was not actived!</p>');
		}
		
		$this->pageTitle = "ACCOUNT ACTIVATION, dnb.sk - Slovak and World drum &amp; bass scene";
		$this->render('activation', 'user');	
	}
}
?>
