<?php

/**
 * Model :: News
 *
 * news.php
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $03.02.2007$
 */

class News extends AppModel
{
    var $name = 'News';
    var $tablePrefix = 'dnb_';
    
    var $feed = array(
	    'conditions' => "published = 'Y' AND CURDATE() >= publish_date",
	    'titleField' => 'News.header',
	    'descField' => 'News.content',
	    'date' => 'publish_date',
	    'category_id' => 'dnb_news_category_id',
	    'fields' => 'dnb_news_category_id, header, content, publish_date, id',
	    'link' => 'news/%s',
	    'orderby' => array('News.created' => 'DESC'),
	    'limit' => 10
	);
		
    function table($offset = 1, $limit = 15, $filter = null) 
	{
		$sql = 'SELECT dnb_users.username, dnb_news_categories.name, dnb_news.id, dnb_news.header, ';
		$sql .= 'dnb_news.published, dnb_news.comments, dnb_news.publish_date, dnb_news.popularity ';
		$sql .= 'FROM   dnb_news, dnb_news_categories, dnb_users ';
		$sql .= 'WHERE  dnb_news_categories.id=dnb_news.dnb_news_category_id AND dnb_users.id=dnb_news.dnb_user_id ';
		if($filter != null)
			$sql .= "AND dnb_news.header LIKE '%".$filter."%' ";
		$sql .= 'ORDER BY publish_date DESC LIMIT '.$offset.','.$limit.'';	
		return $this->query($sql);
	}
	
	function getNews($id = null, $tag = null) 
	{
		if($id == null && $tag == null)
			return false;
			
		$sql = 'SELECT dnb_users.username, dnb_news_categories.name, dnb_news.id, dnb_news.header, ';
		$sql .= 'dnb_news.comments, dnb_news.publish_date, dnb_news.content, dnb_news.popularity, dnb_news_categories.color ';
		$sql .= 'FROM   dnb_news, dnb_news_categories, dnb_users ';
		$sql .= 'WHERE  dnb_news_categories.id=dnb_news.dnb_news_category_id AND dnb_users.id=dnb_news.dnb_user_id ';
		$sql .= "AND dnb_news.published = 'Y' AND CURDATE() >= dnb_news.publish_date ";
		if($tag != null && $id == null)
			$sql .= "AND dnb_news.tag LIKE '".$tag."' ORDER BY dnb_news.publish_date DESC LIMIT 10";
		else
			$sql .= "AND dnb_news.id = '".$id."'";
		return $this->query($sql);
	}
	
	function newsList($offset = 1, $limit = 12) 
	{
		$sql = 'SELECT dnb_users.username, dnb_news_categories.name, dnb_news_categories.color, dnb_news.id, dnb_news.header, ';
		$sql .= 'dnb_news.published, dnb_news.comments, dnb_news.publish_date, dnb_news.excerpt, dnb_news.popularity ';
		$sql .= 'FROM  dnb_news, dnb_news_categories, dnb_users ';
		$sql .= 'WHERE  dnb_news_categories.id=dnb_news.dnb_news_category_id AND dnb_users.id=dnb_news.dnb_user_id ';
		$sql .= 'AND dnb_news.published = \'Y\' AND CURDATE() >= dnb_news.publish_date ORDER BY dnb_news.publish_date DESC, dnb_news.created DESC LIMIT '.$offset.','.$limit.'';	
		return $this->query($sql);
	}
	
	function getCategory($id = null) {
		if($id == null)
			return false;
		$data =  array_pop($this->query("SELECT name FROM dnb_news_categories WHERE id = '".$id."' "));
		return $data['dnb_news_categories']['name'];
	}
	
	function update($id = null, $user_id = null, $stars = 0) 
	{
		return $this->query('UPDATE dnb_news set dnb_user_ids = CONCAT(dnb_user_ids, "['.$user_id.'],"), votes = (votes + 1), count = (count + '.$stars.'), rating = (count / votes) WHERE id = '.$id.'');
	}
}

?>