<?php 
	class RssController extends RssAppController 
	{
		var $name = 'Rss';
		var $helpers = array('Time');
		var $uses = '';
		var $model = null;
		var $date = '';
		var $start = '';
		var $end = '';
		var $fields = null;
		var $club = '';
		var $city = '';
		var $state = '';
		var $additionalElements = array();
		var $titleFields = array('title','name');
		var $descFields = array('desc','description','text','content','body');
		
		function feed() 
		{
			if (empty($this->passed_args[0])) 
			{
				debug('No model was passed.The URL format should be /rss/model');
				$this->redirect('/error404/');
				die;
					}
			$this->modelName=Inflector::classify($this->passed_args[0]);
			loadComponent('Filemanager');
			$filemanager = & new FilemanagerComponent;
			if (!loadModel($this->modelName)) 
			{
				debug('Unable to load the requested model.');
				$this->redirect('/error404/');
				die;
			}
			$this->model = new $this->modelName();
			if (!isset($this->model->feed)) 
			{
				debug('You are not allowed to create a feed from this model.');
				$this->redirect('/error404/');
				die;
			}
			$conditions = null;
			if (isset($this->model->feed['conditions'])) 
			{
				$conditions=$this->model->feed['conditions'];
			}
			$orderby = 'created DESC';
			if (isset($this->model->feed['orderby'])) 
			{
				$orderby=$this->model->feed['orderby'];
			}
			$limit = '10';
			if (isset($this->model->feed['limit'])) 
			{
				$limit = $this->model->feed['limit'];
			}
			if (isset($this->model->feed['date'])) 
			{
				$this->date = $this->model->feed['date'];
			}
			if (isset($this->model->feed['start'])) 
			{
				$this->start = $this->model->feed['start'];
			}
			if (isset($this->model->feed['end'])) 
			{
				$this->end = $this->model->feed['end'];
			}
			if (isset($this->model->feed['fields']))
			{
				$this->fields = $this->model->feed['fields'];
			}
			if (isset($this->model->feed['city'])) 
			{
				$this->city = $this->model->feed['city'];
			}
			if (isset($this->model->feed['club'])) 
			{
				$this->club = $this->model->feed['club'];
			}
			if (isset($this->model->feed['state'])) 
			{
				$this->state = $this->model->feed['state'];
			}
			$data=$this->model->findAll($conditions,$this->fields,$orderby,$limit);
			$rssData = array();
			foreach($data as $i => $item) 
			{
				$temp=array();
				$temp['title'] = $this->__getValue($item,'titleField',$this->titleFields);
				if($this->model->name == 'Party') 
					$temp['desc'] = '<h3>'.$this->__getValue($item,'titleField',$this->titleFields).'</h3><p>'.$item[$this->model->name][$this->date].' * '.$item[$this->model->name][$this->start].' - '.$item[$this->model->name][$this->end].' * '.$this->__getValue($item,'club',$this->club).' * '.$this->__getValue($item,'city',$this->city).' * '.$this->__getValue($item,'state',$this->state).'</p>'.$this->__getValue($item,'descField',$this->descFields);
				else
					$temp['desc'] = '<h3>'.$this->__getValue($item,'titleField',$this->titleFields).'</h3>'.$this->__getValue($item,'descField',$this->descFields);
				if (isset($this->model->feed['club'])) $temp['additionalElements']['club']=$this->__getValue($item,'club',$this->club);
				if (isset($this->model->feed['city'])) $temp['additionalElements']['city']=$this->__getValue($item,'city',$this->city);
				if (isset($this->model->feed['state'])) $temp['additionalElements']['state']=$this->__getValue($item,'state',$this->state);
				if (empty($temp['title']) || empty($temp['desc'])) 
				{
					continue;
				}
				if (isset($this->model->feed['link'])) 
				{
					$temp['link'] = $this->webroot.sprintf($this->model->feed['link'],$item[$this->model->name][$this->model->primaryKey]).'/'.$filemanager->removeAccents($this->__getValue($item,'titleField',$this->titleFields)).'/';
					$temp['comments'] = $this->webroot.sprintf($this->model->feed['link'],$item[$this->model->name][$this->model->primaryKey]).'/'.$filemanager->removeAccents($this->__getValue($item,'titleField',$this->titleFields)).'/#msg_form';
				}
				else 
				{
					$temp['link'] = '/'.$this->model->name.'/view/'.$item[$this->model->name][$this->model->primaryKey];
				}
				$temp['created'] = $item[$this->model->name][$this->date];
			  	if($this->model->name == 'Party') 
					$temp['category']='Parties';
			 	elseif($this->model->name == 'News') 
					$temp['category'] = $this->model->getCategory($item[$this->model->name]['dnb_news_category_id']);
				$rssData[] = $temp;
			}
			$this->set('rssData',$rssData);
			$this->set('feedTitle','DNB.SK, '.Inflector::pluralize($this->model->name));
			$this->set('modelName',$this->model->name);
			$this->set('description','DNB.SK, '.Inflector::pluralize($this->model->name));
			$this->layout = '';
			$this->render('rss');
		}
		
		function __getValue($item,$element,$fields) 
		{
			if (isset($this->model->feed[$element])) 
			{
				if (strpos($this->model->feed[$element],'.') !==false) 
				{
					@list($m,$f) = preg_split('/[.]/',$this->model->feed[$element],2);
					return $item[$m][$f];
				}
				else 
				{
					return $item[$this->model->name][$this->model->feed[$element]];
				}
			}	
			foreach($fields as $field) 
			{
				if (isset($item[$this->model->name][$field])) 
				{
					$temp['title'] = $item[$this->model->name][$field];
				}
			}
			return '';
		}
	}