
/**
 * JS :: Webadm
 *
 * Webadm.js
 *
 * @version        $1.0$
 * @autor   	   $Peter Benicky$
 * @lastmodified   $06.02.2007$
 */
 
function Webadm(webroot) {
	webThis = this;
	this.server = webroot;
	this.admin = webroot+'admin/';
	this.css_images = webroot+'css/admin/images/';
	this.axajRequest = null;	
	this.initialize();
}

Webadm.prototype.initialize = function() {
		$('#loading').hide();
		$('.jscript').show();
		$('.nojscript').hide();
 		$('a.publish').toggle(webThis.unpublish, webThis.publish);
		$('a.unpublish').toggle(webThis.publish, webThis.unpublish);
		$('a.authorized').toggle(webThis.ban, webThis.authorize);
		$('a.to_top').bind('click', $('html'), webThis.top);
		$("input[@name=log_in]").bind('click', webThis.login);
		$('a.banned').toggle(webThis.authorize, webThis.ban);
		$('a.not_done').toggle(webThis.done, webThis.notDone);
		$('a.done').toggle(webThis.notDone, webThis.done);
		$('a.delete').bind('click', webThis.del);
		$('a.delete_comment').bind('click', webThis.del_comment);
		$('a.show').toggle(webThis.show, webThis.hide);
		$('a.delete_file').bind('click', webThis.del_file);
		$('a.color').bind('click', webThis.color);
		$("input.filter").bind('click', webThis.filter);
		$("input.save").bind('click', webThis.save);
		$("input.save_before").bind('click', webThis.saveBefore);
		$('a.delete_file').bind('click', webThis.del_file);
		$("input.save_big").bind('click', webThis.save);
		$('select[@name=group]').bind('change', webThis.setGroup);
		$('form#chat_form').submit(webThis.chat);
		$("input.input_name").bind('click', webThis.clear);
		$("ul.control_panel").hide();
		$("input[@name=send]").bind('click', webThis.send);
}

Webadm.prototype.show = function() {
	$('a.show').css({ background: 'url('+webThis.css_images+'up.gif) no-repeat' });	
	$('a.show').empty().append('Hide admin panel');
	$("ul.control_panel").slideDown("normal");
	return false;	
}

Webadm.prototype.saveBefore = function() {
	$('#loading').show();
}
Webadm.prototype.color = function() {
	var color = prompt('Please enter color in hexadecimal notation, e.g. #FFFFFF.', "#");
	if(!color || color == '' || color == null || color == '#')
		return false;
	$('#loading').show();
	color = color.substring(1);
	var uniq = this.id;
	webThis.ajaxRequest = $.ajax({
		url: this.href+'/'+color+'/',
		success: function(msg){
			if((msg.search('success')) != -1)
				$('a#'+uniq).empty().append("#"+color);
    		$('div#msg').empty().append(msg).fadeIn("slow");
    		$('#loading').hide();
   		}
	});

	return false;	
}

Webadm.prototype.hide = function() {
	$('a.show').css({ background: 'url('+webThis.css_images+'down.gif) no-repeat' });
	$('a.show').empty().append('Show admin panel');
	$("ul.control_panel").slideUp("normal");
	return false;	
}

Webadm.prototype.publish = function() {
	$('#loading').show();
	var id = this.id.substring(this.id.indexOf('-') + 1);
	var uniq = this.id;
	webThis.ajaxRequest = $.ajax({
		url: this.href+'publish/'+id,
		success: function(msg){
    		if((msg.search('success')) != -1)
    			$('a#'+uniq).css({ background: 'url('+webThis.css_images+'publish.gif) no-repeat' });
    		$('div#msg').empty().append(msg).fadeIn("slow");
    		$('#loading').hide();
   		}
	});
	return false;	
}

Webadm.prototype.unpublish = function() {
	$('#loading').show();
	var id = this.id.substring(this.id.indexOf('-') + 1);
	var uniq = this.id;
	webThis.ajaxRequest = $.ajax({
		url: this.href+'unpublish/'+id,
		success: function(msg){
    		if((msg.search('success')) != -1)
    			$('a#'+uniq).css({ background: 'url('+webThis.css_images+'unpublish.gif) no-repeat' });
    		$('div#msg').empty().append(msg).fadeIn("slow");
    		$('#loading').hide();
   		}
	});
	return false;	
}

Webadm.prototype.authorize = function() {
	$('#loading').show();
	var id = this.id.substring(this.id.indexOf('-') + 1);
	var uniq = this.id;
	webThis.ajaxRequest = $.ajax({
		url: this.href+'authorize/'+id,
		success: function(msg){
    		if((msg.search('success')) != -1)
    			$('a#'+uniq).css({ background: 'url('+webThis.css_images+'authorized.gif) no-repeat' });
    		$('div#msg').empty().append(msg).fadeIn("slow");
    		$('#loading').hide();
   		}
	});
	return false;	
}

Webadm.prototype.ban = function() {
	$('#loading').show();
	var id = this.id.substring(this.id.indexOf('-') + 1);
	var uniq = this.id;
	webThis.ajaxRequest = $.ajax({
		url: this.href+'ban/'+id,
		success: function(msg){
    		if((msg.search('success')) != -1)
    			$('a#'+uniq).css({ background: 'url('+webThis.css_images+'banned.gif) no-repeat' });
    		$('div#msg').empty().append(msg).fadeIn("slow");
    		$('#loading').hide();
   		}
	});
	return false;	
}

Webadm.prototype.done = function() {
	$('#loading').show();
	var id = this.id.substring(this.id.indexOf('-') + 1);
	var uniq = this.id;
	webThis.ajaxRequest = $.ajax({
		url: this.href+'done/'+id,
		success: function(msg){
    		if((msg.search('success')) != -1)
    			$('a#'+uniq).css({ background: 'url('+webThis.css_images+'authorized.gif) no-repeat' });
    		$('div#msg').empty().append(msg).fadeIn("slow");
    		$('#loading').hide();
   		}
	});
	return false;	
}

Webadm.prototype.notDone = function() {
	$('#loading').show();
	var id = this.id.substring(this.id.indexOf('-') + 1);
	var uniq = this.id;
	webThis.ajaxRequest = $.ajax({
		url: this.href+'not_done/'+id,
		success: function(msg){
    		if((msg.search('success')) != -1)
    			$('a#'+uniq).css({ background: 'url('+webThis.css_images+'not_done.gif) no-repeat' });
    		$('div#msg').empty().append(msg).fadeIn("slow");
    		$('#loading').hide();
   		}
	});
	return false;	
}

Webadm.prototype.del = function() {
	var con = confirm('Are sure you want to delete this entry?');
	if(con) {
		$('#loading').show();
		var id = this.id.substring(this.id.indexOf('-') + 1);
		webThis.ajaxRequest = $.ajax({
			url: this.href+'delete/'+id,
			success: function(msg){
	    		if((msg.search('success')) != -1)
	    			$('tr#tr-'+id).remove();
	    		$('div#msg').empty().append(msg).fadeIn("slow");
	    		$('#loading').hide();
	   		}
		});
	}
	return false;	
}

Webadm.prototype.del_comment = function() {
	var con = confirm('Are sure you want to delete this entry?');
	if(con) {
		$('#loading').show();
		var id = this.id.substring(this.id.indexOf('-') + 1);
		webThis.ajaxRequest = $.ajax({
			url: this.href,
			success: function(msg){
				if((msg.search('success')) != -1)
	    			$('tr#tr-'+id).remove();
	    		$('div#msg').empty().append(msg).fadeIn("slow");
	    		$('#loading').hide();
	   		}
		});
	}
	return false;	
}

Webadm.prototype.filter = function() {
	if($('input.input_filter').get(0).value == '') {
		$('div#msg').empty().append('<p class="warning">You must enter string for filter!</p>').fadeIn("slow");
		return false;
	}
}

Webadm.prototype.save = function() {
	$('#loading').show();
	var empty = false;
 	$('input[@type=text]').not('.input_no_check').each(function(input) { 
   		if(this.value == '')
			empty = true;
 	 });
 	 if(empty) {
 	 	$('div#msg').empty().append('<p class="warning">You left some empty fields, fill it first!</p>').fadeIn("slow");
		window.scroll(0,0);
		$('#loading').hide();
		return false;
 	 }		
}
Webadm.prototype.top = function() {
	window.scroll(0,0);
	return false;
}
Webadm.prototype.setGroup = function() {
	$('#loading').show();
	webThis.ajaxRequest = $.ajax({
			type: 'POST',
			url: webThis.admin+'users/set_group/',
			data: this.value,
			success: function(msg){
	    		$('div#msg').empty().append(msg).fadeIn("slow");
	    		$('#loading').hide();
	   		}
	});
	return false;		
}

Webadm.prototype.clear = function() {
	$('input.input_name').get(0).value = '';	
}

Webadm.prototype.del_file = function() {
	var con = confirm('Are sure you want to delete this file?');
	if(con) {
		$('#loading').show();
		var id = this.id.substring(this.id.indexOf('-') + 1);
		webThis.ajaxRequest = $.ajax({
			type: 'POST',
			url: this.href+'delete_file/',
			data: this.rel,
			success: function(msg){
	    		if((msg.search('success')) != -1)
	    			$('tr#tr-'+id).remove(); 
	    		$('div#msg').empty().append(msg).fadeIn("slow");
	    		$('#loading').hide();
	   		}
		});
	}
	return false;	
}

Webadm.prototype.chat = function() {
	var message = $('input[@name=message]').get(0).value;
	var userId = $('input[@name=user_id]').get(0).value;
	$.post(webThis.admin+'chat_messages/add/', {message: message, id: userId});
	$('input[@name=message]').get(0).value = '';
	$('#loading').hide();
	return false;
}

Webadm.prototype.updateChat = function() {
		$('#chat p').load(webThis.admin+'chat_messages/view/'+Math.random()); 
        setTimeout('webThis.updateChat()', 1000);      
}

Webadm.prototype.login = function() {
	$('#loading').show();
	var login = $('input[@name=login]').get(0).value;
	var password = webThis.sha1($('input[@name=password]').get(0).value);
	$.post(
		webThis.admin+'users/login/', 
		{login: login, password: password},
		function(msg){
			if((msg.search('error')) != -1)
    			$('div#msg').empty().append(msg).fadeIn("slow");
    		else
    			window.location = webThis.admin+'welcome/';
    	$('#loading').hide();
   		}
	);
	return false;
}

Webadm.prototype.send = function() {
	$('#loading').show();
	var message = $('textarea[@name=message]').get(0).value;
	var userId = $('input[@name=user_id]').get(0).value;
	var subject = $('input[@name=subject]').get(0).value;
	var users = $('input[@name=users]').get(0).value;
	var type = $('select[@name=type]').get(0).value;
	if(message == '' || subject == '' || users == '' || userId == '') {
		$('div#msg').empty().append('<p class="warning">You left some empty fields, fill it first!</p>').fadeIn("slow");
		$('#loading').hide();
		return false;
	}
	$.post(
		webThis.admin+'messages/send/', 
		{message: message, id: userId, subject: subject, users: users, type: type},
		function(msg){
    		$('div#msg').empty().append(msg).fadeIn("slow");
    		$('#loading').hide();
   		}
	);
	return false;
}

Webadm.prototype.sha1 = function(msg) {

	function rotate_left(n,s) {
		var t4 = ( n<<s ) | (n>>>(32-s));
		return t4;
	};

	function lsb_hex(val) {
		var str="";
		var i;
		var vh;
		var vl;

		for( i=0; i<=6; i+=2 ) {
			vh = (val>>>(i*4+4))&0x0f;
			vl = (val>>>(i*4))&0x0f;
			str += vh.toString(16) + vl.toString(16);
		}
		return str;
	};

	function cvt_hex(val) {
		var str="";
		var i;
		var v;

		for( i=7; i>=0; i-- ) {
			v = (val>>>(i*4))&0x0f;
			str += v.toString(16);
		}
		return str;
	};


	function Utf8Encode(string) {
		string = string.replace(/\r\n/g,"\n");
		var utftext = "";

		for (var n = 0; n < string.length; n++) {

			var c = string.charCodeAt(n);

			if (c < 128) {
				utftext += String.fromCharCode(c);
			}
			else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			}
			else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}

		}

		return utftext;
	};

	var blockstart;
	var i, j;
	var W = new Array(80);
	var H0 = 0x67452301;
	var H1 = 0xEFCDAB89;
	var H2 = 0x98BADCFE;
	var H3 = 0x10325476;
	var H4 = 0xC3D2E1F0;
	var A, B, C, D, E;
	var temp;

	msg = Utf8Encode(msg);

	var msg_len = msg.length;

	var word_array = new Array();
	for( i=0; i<msg_len-3; i+=4 ) {
		j = msg.charCodeAt(i)<<24 | msg.charCodeAt(i+1)<<16 |
		msg.charCodeAt(i+2)<<8 | msg.charCodeAt(i+3);
		word_array.push( j );
	}

	switch( msg_len % 4 ) {
		case 0:
			i = 0x080000000;
		break;
		case 1:
			i = msg.charCodeAt(msg_len-1)<<24 | 0x0800000;
		break;

		case 2:
			i = msg.charCodeAt(msg_len-2)<<24 | msg.charCodeAt(msg_len-1)<<16 | 0x08000;
		break;

		case 3:
			i = msg.charCodeAt(msg_len-3)<<24 | msg.charCodeAt(msg_len-2)<<16 | msg.charCodeAt(msg_len-1)<<8	| 0x80;
		break;
	}

	word_array.push( i );

	while( (word_array.length % 16) != 14 ) word_array.push( 0 );

	word_array.push( msg_len>>>29 );
	word_array.push( (msg_len<<3)&0x0ffffffff );


	for ( blockstart=0; blockstart<word_array.length; blockstart+=16 ) {

		for( i=0; i<16; i++ ) W[i] = word_array[blockstart+i];
		for( i=16; i<=79; i++ ) W[i] = rotate_left(W[i-3] ^ W[i-8] ^ W[i-14] ^ W[i-16], 1);

		A = H0;
		B = H1;
		C = H2;
		D = H3;
		E = H4;

		for( i= 0; i<=19; i++ ) {
			temp = (rotate_left(A,5) + ((B&C) | (~B&D)) + E + W[i] + 0x5A827999) & 0x0ffffffff;
			E = D;
			D = C;
			C = rotate_left(B,30);
			B = A;
			A = temp;
		}

		for( i=20; i<=39; i++ ) {
			temp = (rotate_left(A,5) + (B ^ C ^ D) + E + W[i] + 0x6ED9EBA1) & 0x0ffffffff;
			E = D;
			D = C;
			C = rotate_left(B,30);
			B = A;
			A = temp;
		}

		for( i=40; i<=59; i++ ) {
			temp = (rotate_left(A,5) + ((B&C) | (B&D) | (C&D)) + E + W[i] + 0x8F1BBCDC) & 0x0ffffffff;
			E = D;
			D = C;
			C = rotate_left(B,30);
			B = A;
			A = temp;
		}

		for( i=60; i<=79; i++ ) {
			temp = (rotate_left(A,5) + (B ^ C ^ D) + E + W[i] + 0xCA62C1D6) & 0x0ffffffff;
			E = D;
			D = C;
			C = rotate_left(B,30);
			B = A;
			A = temp;
		}

		H0 = (H0 + A) & 0x0ffffffff;
		H1 = (H1 + B) & 0x0ffffffff;
		H2 = (H2 + C) & 0x0ffffffff;
		H3 = (H3 + D) & 0x0ffffffff;
		H4 = (H4 + E) & 0x0ffffffff;

	}

	var temp = cvt_hex(H0) + cvt_hex(H1) + cvt_hex(H2) + cvt_hex(H3) + cvt_hex(H4);

	return temp.toLowerCase();
}
