<?php class TimeHelper extends Helper { function trim($string,$length,$ending='..') { return substr($string,0,$length).(strlen($string) > $length ? $ending:null);} function fromString($date_string) { if (is_integer($date_string) || is_numeric($date_string)) { return intval($date_string);} else { return strtotime($date_string);} } function nice($date_string=null) { if ($date_string !=null) { $date=$this->fromString($date_string);} else { $date=time();} $ret=date("D, M jS Y, H:i",$date);return $this->output($ret);} function niceTime($time_string=null) { if ($time_string !=null) { $date=$this->fromString($time_string);} else { $date=time();} $ret=date("H:i",$date);return $this->output($ret);} function niceShort($date_string=null) { $date=$date_string ? $this->fromString($date_string):time();$y=$this->isThisYear($date) ? '':' Y';if ($this->isToday($date)) { $ret="Today, ".date("H:i",$date);} elseif($this->wasYesterday($date)) { $ret="Yesterday, ".date("H:i", $date);} else { $ret=date("M jS{$y}, H:i", $date);} return $this->output($ret);} function niceDate($date_string=null) { $date=$date_string ? $this->fromString($date_string):time();$y=$this->isThisYear($date) ? '':' Y';if ($this->isToday($date)) { $ret="Today";} elseif($this->wasYesterday($date)) { $ret="Yesterday";} else { $ret=date("D, M jS{$y}",$date);} return $this->output($ret);} function daysAsSql($begin,$end,$field_name) { $begin=$this->fromString($begin);$end=$this->fromString($end);$begin=date('Y-m-d',$begin).' 00:00:00';$end=date('Y-m-d',$end).' 23:59:59';$ret="($field_name >='$begin') AND ($field_name <='$end')";return $this->output($ret);} function dayAsSql($date_string,$field_name) { $date=$this->fromString($date_string);$ret=$this->daysAsSql($date_string,$date_string,$field_name);return $this->output($ret);} function isToday($date_string) { $date=$this->fromString($date_string);$ret=date('Y-m-d',$date)==date('Y-m-d',time());return $this->output($ret);} function isThisWeek($date_string) { $date=$this->fromString($date_string)+86400;return date('W Y',$date)==date('W Y',time());} function isThisMonth($date_string) { $date=$this->fromString($date_string);return date('m Y',$date)==date('m Y',time());} function isThisYear($date_string) { $date=$this->fromString($date_string);$ret=date('Y',$date)==date('Y',time());return $this->output($ret);} function wasYesterday($date_string) { $date=$this->fromString($date_string);$ret=date('Y-m-d',$date)==date('Y-m-d',strtotime('yesterday'));return $this->output($ret);} function isTomorrow($date_string) { $date=$this->fromString($date_string);$ret=date('Y-m-d',$date)==date('Y-m-d',strtotime('tomorrow'));return $this->output($ret);} function toUnix($date_string) { $ret=strtotime($date_string);return $this->output($ret);} function toAtom($date_string) { $date=$this->fromString($date_string);$ret=date('Y-m-d\TH:i:s\Z',$date);return $this->output($ret);} function toRSS($date_string) { $date=TimeHelper::fromString($date_string);$ret=date("r",$date);return $this->output($ret);} function timeAgoInWords($datetime_string,$format='j/n/y',$backwards=false) { $datetime=$this->fromString($datetime_string);$in_seconds=$datetime;if ($backwards) { $diff=$in_seconds-time();} else { $diff=time()-$in_seconds;} $months=floor($diff / 2419200);$diff-=$months * 2419200;$weeks=floor($diff / 604800);$diff-=$weeks * 604800;$days=floor($diff / 86400);$diff-=$days * 86400;$hours=floor($diff / 3600);$diff-=$hours * 3600;$minutes=floor($diff / 60);$diff-=$minutes * 60;$seconds=$diff;if ($months > 0) { $relative_date='on '.date($format,$in_seconds);$old=true;} else { $relative_date='';$old=false;if ($weeks > 0) { $relative_date.=($relative_date ? ',':'').$weeks.' week'.($weeks > 1 ? 's':'');$relative_date.=$days > 0 ? ($relative_date ? ',':'').$days.' day'.($days > 1 ? 's':''):'';} elseif($days > 0) { $relative_date.=($relative_date ? ',':'').$days.' day'.($days > 1 ? 's':'');$relative_date.=$hours > 0 ? ($relative_date ? ',':'').$hours.' hour'.($hours > 1 ? 's':''):'';} elseif($hours > 0) { $relative_date.=($relative_date ? ',':'').$hours.' hour'.($hours > 1 ? 's':'');$relative_date.=$minutes > 0 ? ($relative_date ? ',':'').$minutes.' minute'.($minutes > 1 ? 's':''):'';} elseif($minutes > 0) { $relative_date.=($relative_date ? ',':'').$minutes.' minute'.($minutes > 1 ? 's':'');} else { $relative_date.=($relative_date ? ',':'').$seconds.' second'.($seconds !=1 ? 's':'');} } $ret=$relative_date;if (!$backwards && !$old) { $ret.=' ago';} return $this->output($ret);} function relativeTime($datetime_string,$format='j/n/y') { $date=strtotime($datetime_string);if (strtotime("now") > $date) { $ret=$this->timeAgoInWords($datetime_string,$format,false);} else { $ret=$this->timeAgoInWords($datetime_string,$format,true);} return $this->output($ret);} function wasWithinLast($timeInterval,$date_string) { $date=$this->fromString($date_string);$result=preg_split('/\\s/',$timeInterval);$numInterval=$result[0];$textInterval=$result[1];$currentTime=floor(time());$seconds=($currentTime-floor($date));switch($textInterval) { case "seconds":case "second":$timePeriod=$seconds;$ret=$return;break;case "minutes":case "minute":$minutes=floor($seconds / 60);$timePeriod=$minutes;break;case "hours":case "hour":$hours=floor($seconds / 3600);$timePeriod=$hours;break;case "days":case "day":$days=floor($seconds / 86400);$timePeriod=$days;break;case "weeks":case "week":$weeks=floor($seconds / 604800);$timePeriod=$weeks;break;case "months":case "month":$months=floor($seconds / 2629743.83);$timePeriod=$months;break;case "years":case "year":$years=floor($seconds / 31556926);$timePeriod=$years;break;default:$days=floor($seconds / 86400);$timePeriod=$days;break;} if ($timePeriod <=$numInterval) { $ret=true;} else { $ret=false;} return $this->output($ret);} function gmt($string=null) { if ($string !=null) { $string=$this->fromString($string);} else { $string=time();} $string=$this->fromString($string);$hour=intval(date("G",$string));$minute=intval(date("i",$string));$second=intval(date("s",$string));$month=intval(date("n",$string));$day=intval(date("j",$string));$year=intval(date("Y",$string));$return=gmmktime($hour,$minute,$second,$month,$day,$year);return $return;} function format($format='d-m-Y',$date) { return date($format,$this->fromString($date));} } ?>
